Statistics
| Branch: | Tag: | Revision:

root / Makefile.am @ 7c88c7af

History | View | Annotate | Download (43.4 kB)

1 e8230860 Michael Hanselmann
# Ganeti makefile
2 e8230860 Michael Hanselmann
# - Indent with tabs only.
3 e8230860 Michael Hanselmann
# - Keep files sorted; one line per file.
4 e8230860 Michael Hanselmann
# - Directories in lib/ must have their own *dir variable (see hypervisor).
5 e8230860 Michael Hanselmann
# - All directories must be listed DIRS.
6 0a7bed64 Michael Hanselmann
# - Use autogen.sh to generate Makefile.in and configure script.
7 e8230860 Michael Hanselmann
8 e8230860 Michael Hanselmann
# Automake doesn't export these variables before version 1.10.
9 e8230860 Michael Hanselmann
abs_top_builddir = @abs_top_builddir@
10 e8230860 Michael Hanselmann
abs_top_srcdir = @abs_top_srcdir@
11 e8230860 Michael Hanselmann
12 08366664 Michael Hanselmann
# Helper values for calling builtin functions
13 08366664 Michael Hanselmann
empty :=
14 08366664 Michael Hanselmann
space := $(empty) $(empty)
15 08366664 Michael Hanselmann
comma := ,
16 08366664 Michael Hanselmann
17 a01dd3c6 Iustin Pop
# Use bash in order to be able to use pipefail
18 a01dd3c6 Iustin Pop
SHELL=/bin/bash
19 a01dd3c6 Iustin Pop
20 6e06b36c Iustin Pop
ACLOCAL_AMFLAGS = -I autotools
21 4f3d5b76 Michael Hanselmann
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 b959138f Michael Hanselmann
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 eed5c5df Michael Hanselmann
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 5d3c30df Michael Hanselmann
CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 c55cc346 Iustin Pop
CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 73d0e218 Iustin Pop
CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 96602be4 Michael Hanselmann
CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 7385c51d Michael Hanselmann
CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 f6cbcc06 Michael Hanselmann
CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 95eb4188 Michael Hanselmann
DOCPP = $(top_srcdir)/autotools/docpp
31 e8230860 Michael Hanselmann
REPLACE_VARS_SED = autotools/replace_vars.sed
32 d99d1e36 Iustin Pop
CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 d5a2a550 Michael Hanselmann
BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 e8230860 Michael Hanselmann
35 22c5390d Iustin Pop
# Note: these are automake-specific variables, and must be named after
36 22c5390d Iustin Pop
# the directory + 'dir' suffix
37 2d48a3a2 Michael Hanselmann
clientdir = $(pkgpythondir)/client
38 e8230860 Michael Hanselmann
hypervisordir = $(pkgpythondir)/hypervisor
39 ff9efc03 Michael Hanselmann
httpdir = $(pkgpythondir)/http
40 dc101ecc Michael Hanselmann
masterddir = $(pkgpythondir)/masterd
41 12426ae1 Guido Trotter
confddir = $(pkgpythondir)/confd
42 8c229cc7 Oleksiy Mishchenko
rapidir = $(pkgpythondir)/rapi
43 899c4d2c Michael Hanselmann
serverdir = $(pkgpythondir)/server
44 9f4bb951 Michael Hanselmann
watcherdir = $(pkgpythondir)/watcher
45 bb44b1ae Michael Hanselmann
impexpddir = $(pkgpythondir)/impexpd
46 c047a981 Michael Hanselmann
utilsdir = $(pkgpythondir)/utils
47 e8230860 Michael Hanselmann
toolsdir = $(pkglibdir)/tools
48 7617fd6b Iustin Pop
iallocatorsdir = $(pkglibdir)/iallocators
49 0d2bf835 René Nussbaumer
pytoolsdir = $(pkgpythondir)/tools
50 e8230860 Michael Hanselmann
docdir = $(datadir)/doc/$(PACKAGE)
51 b8fe7ca6 Iustin Pop
myexeclibdir = $(pkglibdir)
52 e8230860 Michael Hanselmann
53 a4f12da4 Michael Hanselmann
# Delete output file if an error occurred while building it
54 a4f12da4 Michael Hanselmann
.DELETE_ON_ERROR:
55 a4f12da4 Michael Hanselmann
56 d5506465 Iustin Pop
HTOOLS_DIRS = \
57 d5506465 Iustin Pop
	htools \
58 d5506465 Iustin Pop
	htools/Ganeti \
59 358a0a8f Iustin Pop
	htools/Ganeti/Confd \
60 458a286a Iustin Pop
	htools/Ganeti/HTools \
61 458a286a Iustin Pop
	htools/Ganeti/HTools/Program
62 d5506465 Iustin Pop
63 e8230860 Michael Hanselmann
DIRS = \
64 e8230860 Michael Hanselmann
	autotools \
65 e8230860 Michael Hanselmann
	daemons \
66 e8230860 Michael Hanselmann
	devel \
67 e8230860 Michael Hanselmann
	doc \
68 e8230860 Michael Hanselmann
	doc/examples \
69 d6d9ce45 Guido Trotter
	doc/examples/hooks \
70 c51580b3 Guido Trotter
	doc/examples/gnt-debug \
71 d5506465 Iustin Pop
	$(HTOOLS_DIRS) \
72 e8230860 Michael Hanselmann
	lib \
73 2d48a3a2 Michael Hanselmann
	lib/client \
74 f9897b6d Michael Hanselmann
	lib/build \
75 2f16ea8f Michael Hanselmann
	lib/confd \
76 ff9efc03 Michael Hanselmann
	lib/http \
77 e8230860 Michael Hanselmann
	lib/hypervisor \
78 bb44b1ae Michael Hanselmann
	lib/impexpd \
79 dc101ecc Michael Hanselmann
	lib/masterd \
80 8c229cc7 Oleksiy Mishchenko
	lib/rapi \
81 899c4d2c Michael Hanselmann
	lib/server \
82 0d2bf835 René Nussbaumer
	lib/tools \
83 c047a981 Michael Hanselmann
	lib/utils \
84 9f4bb951 Michael Hanselmann
	lib/watcher \
85 e8230860 Michael Hanselmann
	man \
86 e8230860 Michael Hanselmann
	qa \
87 e8230860 Michael Hanselmann
	test \
88 e8230860 Michael Hanselmann
	test/data \
89 6bbd76d2 Iustin Pop
	test/data/htools \
90 91e5a351 Iustin Pop
	test/data/htools/rapi \
91 1e6fab60 Agata Murawska
	test/data/ovfdata \
92 d92518d3 Agata Murawska
	test/data/ovfdata/other \
93 e8230860 Michael Hanselmann
	tools
94 e8230860 Michael Hanselmann
95 2750b299 Michael Hanselmann
BUILDTIME_DIR_AUTOCREATE = \
96 c964d962 Michael Hanselmann
	scripts \
97 22c5390d Iustin Pop
	$(APIDOC_DIR) \
98 22c5390d Iustin Pop
	$(APIDOC_PY_DIR) \
99 22c5390d Iustin Pop
	$(APIDOC_HS_DIR) \
100 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti \
101 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Confd \
102 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools \
103 458a286a Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools/Program \
104 22c5390d Iustin Pop
	$(COVERAGE_DIR) \
105 22c5390d Iustin Pop
	$(COVERAGE_PY_DIR) \
106 22c5390d Iustin Pop
	$(COVERAGE_HS_DIR) \
107 b91e9518 Iustin Pop
	.hpc
108 2750b299 Michael Hanselmann
109 2750b299 Michael Hanselmann
BUILDTIME_DIRS = \
110 2750b299 Michael Hanselmann
	$(BUILDTIME_DIR_AUTOCREATE) \
111 6b997854 Michael Hanselmann
	doc/html
112 6b997854 Michael Hanselmann
113 6b997854 Michael Hanselmann
DIRCHECK_EXCLUDE = \
114 6b997854 Michael Hanselmann
	$(BUILDTIME_DIRS) \
115 6b997854 Michael Hanselmann
	ganeti-[0-9]*.[0-9]*.[0-9]* \
116 6b997854 Michael Hanselmann
	doc/html/_*
117 6b997854 Michael Hanselmann
118 2750b299 Michael Hanselmann
all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
119 c964d962 Michael Hanselmann
120 22c5390d Iustin Pop
# some helper vars
121 22c5390d Iustin Pop
COVERAGE_DIR = doc/coverage
122 22c5390d Iustin Pop
COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
123 22c5390d Iustin Pop
COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
124 22c5390d Iustin Pop
APIDOC_DIR = doc/api
125 22c5390d Iustin Pop
APIDOC_PY_DIR = $(APIDOC_DIR)/py
126 22c5390d Iustin Pop
APIDOC_HS_DIR = $(APIDOC_DIR)/hs
127 22c5390d Iustin Pop
128 2ab2b9f5 Iustin Pop
MAINTAINERCLEANFILES = \
129 d17e74b4 Iustin Pop
	$(docpng) \
130 b76aac08 Michael Hanselmann
	$(maninput) \
131 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
132 84a12e40 Iustin Pop
	doc/news.rst \
133 7a03d293 Michael Hanselmann
	doc/upgrade.rst \
134 84a12e40 Iustin Pop
	vcs-version
135 2ab2b9f5 Iustin Pop
136 d17e74b4 Iustin Pop
maintainer-clean-local:
137 6b997854 Michael Hanselmann
	rm -rf $(BUILDTIME_DIRS)
138 d17e74b4 Iustin Pop
139 e8230860 Michael Hanselmann
CLEANFILES = \
140 2f16ea8f Michael Hanselmann
	$(addsuffix /*.py[co],$(DIRS)) \
141 d5506465 Iustin Pop
	$(addsuffix /*.hi,$(HTOOLS_DIRS)) \
142 d5506465 Iustin Pop
	$(addsuffix /*.o,$(HTOOLS_DIRS)) \
143 c964d962 Michael Hanselmann
	$(all_dirfiles) \
144 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
145 f774bd03 Michael Hanselmann
	epydoc.conf \
146 e8230860 Michael Hanselmann
	autotools/replace_vars.sed \
147 f154a7a3 Michael Hanselmann
	daemons/daemon-util \
148 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner \
149 e8230860 Michael Hanselmann
	devel/upload \
150 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
151 f72f8622 Iustin Pop
	doc/examples/bash_completion \
152 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py \
153 2ab2b9f5 Iustin Pop
	$(man_MANS) \
154 2ab2b9f5 Iustin Pop
	$(manhtml) \
155 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
156 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
157 d6159933 Iustin Pop
	$(nodist_pkgpython_PYTHON) \
158 c3f67183 Iustin Pop
	$(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
159 3096524e Iustin Pop
	$(HS_BUILT_TEST_HELPERS) \
160 191ff68c Iustin Pop
	.hpc/*.mix htools/*.tix \
161 191ff68c Iustin Pop
	doc/hs-lint.html
162 e8230860 Michael Hanselmann
163 a13d6911 Iustin Pop
# BUILT_SOURCES should only be used as a dependency on phony
164 a13d6911 Iustin Pop
# targets. Otherwise it'll cause the target to rebuild every time.
165 dc7d2c49 Michael Hanselmann
BUILT_SOURCES = \
166 96a7481d Michael Hanselmann
  $(built_base_sources) \
167 96a7481d Michael Hanselmann
	$(BUILT_PYTHON_SOURCES) \
168 96a7481d Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
169 96a7481d Michael Hanselmann
170 96a7481d Michael Hanselmann
built_base_sources = \
171 dc7d2c49 Michael Hanselmann
	ganeti \
172 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
173 96a7481d Michael Hanselmann
	$(all_dirfiles)
174 2d1f248e Michael Hanselmann
175 96a7481d Michael Hanselmann
built_python_base_sources = \
176 13aeae6a Iustin Pop
	lib/_autoconf.py \
177 96a7481d Michael Hanselmann
	lib/_vcsversion.py
178 96a7481d Michael Hanselmann
179 96a7481d Michael Hanselmann
BUILT_PYTHON_SOURCES = \
180 96a7481d Michael Hanselmann
	$(built_python_base_sources) \
181 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py
182 e8230860 Michael Hanselmann
183 96a7481d Michael Hanselmann
# Generating the RPC wrappers depends on many things, so make sure it's built at
184 96a7481d Michael Hanselmann
# the end of the built sources
185 96a7481d Michael Hanselmann
lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
186 96a7481d Michael Hanselmann
187 656a7fdf Iustin Pop
# these are all built from the underlying %.in sources
188 656a7fdf Iustin Pop
BUILT_EXAMPLES = \
189 656a7fdf Iustin Pop
	doc/examples/ganeti-kvm-poweroff.initd \
190 656a7fdf Iustin Pop
	doc/examples/ganeti.cron \
191 656a7fdf Iustin Pop
	doc/examples/ganeti.initd \
192 656a7fdf Iustin Pop
	doc/examples/gnt-config-backup \
193 656a7fdf Iustin Pop
	doc/examples/hooks/ipsec
194 656a7fdf Iustin Pop
195 08366664 Michael Hanselmann
nodist_pkgpython_PYTHON = \
196 08366664 Michael Hanselmann
	$(BUILT_PYTHON_SOURCES)
197 08366664 Michael Hanselmann
198 f9897b6d Michael Hanselmann
noinst_PYTHON = \
199 5f43f393 Michael Hanselmann
	lib/build/__init__.py \
200 7142485a Iustin Pop
	lib/build/sphinx_ext.py \
201 7142485a Iustin Pop
	lib/build/shell_example_lexer.py
202 f9897b6d Michael Hanselmann
203 e8230860 Michael Hanselmann
pkgpython_PYTHON = \
204 e8230860 Michael Hanselmann
	lib/__init__.py \
205 a8a76bc2 Guido Trotter
	lib/asyncnotifier.py \
206 e8230860 Michael Hanselmann
	lib/backend.py \
207 e8230860 Michael Hanselmann
	lib/bdev.py \
208 e8230860 Michael Hanselmann
	lib/bootstrap.py \
209 e8230860 Michael Hanselmann
	lib/cli.py \
210 e8230860 Michael Hanselmann
	lib/cmdlib.py \
211 cea881e5 Michael Hanselmann
	lib/compat.py \
212 e8230860 Michael Hanselmann
	lib/config.py \
213 e8230860 Michael Hanselmann
	lib/constants.py \
214 821d9e43 Michael Hanselmann
	lib/daemon.py \
215 e8230860 Michael Hanselmann
	lib/errors.py \
216 62e0e880 Iustin Pop
	lib/ht.py \
217 e8230860 Michael Hanselmann
	lib/jqueue.py \
218 8b537bb0 Michael Hanselmann
	lib/jstore.py \
219 e8230860 Michael Hanselmann
	lib/locking.py \
220 e8230860 Michael Hanselmann
	lib/luxi.py \
221 e8230860 Michael Hanselmann
	lib/mcpu.py \
222 a744b676 Manuel Franceschini
	lib/netutils.py \
223 e8230860 Michael Hanselmann
	lib/objects.py \
224 e8230860 Michael Hanselmann
	lib/opcodes.py \
225 ced78a66 Agata Murawska
	lib/ovf.py \
226 a123dc19 Michael Hanselmann
	lib/qlang.py \
227 4ca96421 Michael Hanselmann
	lib/query.py \
228 e8230860 Michael Hanselmann
	lib/rpc.py \
229 6648cb36 Michael Hanselmann
	lib/rpc_defs.py \
230 f12e1736 René Nussbaumer
	lib/runtime.py \
231 e8230860 Michael Hanselmann
	lib/serializer.py \
232 e8230860 Michael Hanselmann
	lib/ssconf.py \
233 e8230860 Michael Hanselmann
	lib/ssh.py \
234 ac2d0fe4 Michael Hanselmann
	lib/storage.py \
235 1338f2b4 Balazs Lecz
	lib/uidpool.py \
236 76094e37 Michael Hanselmann
	lib/workerpool.py
237 e8230860 Michael Hanselmann
238 2d48a3a2 Michael Hanselmann
client_PYTHON = \
239 c2855a12 Michael Hanselmann
	lib/client/__init__.py \
240 02266fe0 Michael Hanselmann
	lib/client/gnt_backup.py \
241 7b3e7d41 Michael Hanselmann
	lib/client/gnt_cluster.py \
242 6d50f5f9 Michael Hanselmann
	lib/client/gnt_debug.py \
243 667dbd6b Adeodato Simo
	lib/client/gnt_group.py \
244 e792102d Michael Hanselmann
	lib/client/gnt_instance.py \
245 a09b9e3d Michael Hanselmann
	lib/client/gnt_job.py \
246 37494fa4 Michael Hanselmann
	lib/client/gnt_node.py \
247 9bcef16f Constantinos Venetsanopoulos
	lib/client/gnt_os.py \
248 9bcef16f Constantinos Venetsanopoulos
	lib/client/gnt_storage.py
249 2d48a3a2 Michael Hanselmann
250 e8230860 Michael Hanselmann
hypervisor_PYTHON = \
251 e8230860 Michael Hanselmann
	lib/hypervisor/__init__.py \
252 e8230860 Michael Hanselmann
	lib/hypervisor/hv_base.py \
253 48297fa2 Iustin Pop
	lib/hypervisor/hv_chroot.py \
254 e8230860 Michael Hanselmann
	lib/hypervisor/hv_fake.py \
255 eb58f9b1 Guido Trotter
	lib/hypervisor/hv_kvm.py \
256 4b5e40a5 Iustin Pop
	lib/hypervisor/hv_lxc.py \
257 e8230860 Michael Hanselmann
	lib/hypervisor/hv_xen.py
258 e8230860 Michael Hanselmann
259 8c229cc7 Oleksiy Mishchenko
rapi_PYTHON = \
260 8c229cc7 Oleksiy Mishchenko
	lib/rapi/__init__.py \
261 10b207d4 Oleksiy Mishchenko
	lib/rapi/baserlib.py \
262 95ab4de9 David Knowles
	lib/rapi/client.py \
263 20b509de Michael Hanselmann
	lib/rapi/client_utils.py \
264 10b207d4 Oleksiy Mishchenko
	lib/rapi/connector.py \
265 a85f23fa Michael Hanselmann
	lib/rapi/rlib2.py \
266 a85f23fa Michael Hanselmann
	lib/rapi/testutils.py
267 8c229cc7 Oleksiy Mishchenko
268 ff9efc03 Michael Hanselmann
http_PYTHON = \
269 02cab3e7 Michael Hanselmann
	lib/http/__init__.py \
270 be500c29 Michael Hanselmann
	lib/http/auth.py \
271 02cab3e7 Michael Hanselmann
	lib/http/client.py \
272 02cab3e7 Michael Hanselmann
	lib/http/server.py
273 ff9efc03 Michael Hanselmann
274 12426ae1 Guido Trotter
confd_PYTHON = \
275 71f27d19 Guido Trotter
	lib/confd/__init__.py \
276 e4ccf6cd Guido Trotter
	lib/confd/client.py \
277 2f16ea8f Michael Hanselmann
	lib/confd/querylib.py \
278 2f16ea8f Michael Hanselmann
	lib/confd/server.py
279 8c229cc7 Oleksiy Mishchenko
280 dc101ecc Michael Hanselmann
masterd_PYTHON = \
281 033a1d00 Michael Hanselmann
	lib/masterd/__init__.py \
282 033a1d00 Michael Hanselmann
	lib/masterd/instance.py
283 dc101ecc Michael Hanselmann
284 bb44b1ae Michael Hanselmann
impexpd_PYTHON = \
285 bb44b1ae Michael Hanselmann
	lib/impexpd/__init__.py
286 bb44b1ae Michael Hanselmann
287 9f4bb951 Michael Hanselmann
watcher_PYTHON = \
288 9ca87fb3 Michael Hanselmann
	lib/watcher/__init__.py \
289 adf6301e Michael Hanselmann
	lib/watcher/nodemaint.py \
290 adf6301e Michael Hanselmann
	lib/watcher/state.py
291 9f4bb951 Michael Hanselmann
292 899c4d2c Michael Hanselmann
server_PYTHON = \
293 29d91329 Michael Hanselmann
	lib/server/__init__.py \
294 5c9c0e0e Michael Hanselmann
	lib/server/confd.py \
295 5119f2ec Michael Hanselmann
	lib/server/masterd.py \
296 d9c82a4e Michael Hanselmann
	lib/server/noded.py \
297 d9c82a4e Michael Hanselmann
	lib/server/rapi.py
298 899c4d2c Michael Hanselmann
299 0d2bf835 René Nussbaumer
pytools_PYTHON = \
300 0d2bf835 René Nussbaumer
	lib/tools/__init__.py \
301 0d2bf835 René Nussbaumer
	lib/tools/ensure_dirs.py
302 0d2bf835 René Nussbaumer
303 c047a981 Michael Hanselmann
utils_PYTHON = \
304 4fd029cf Michael Hanselmann
	lib/utils/__init__.py \
305 79d22269 Michael Hanselmann
	lib/utils/algo.py \
306 9d1b963f Michael Hanselmann
	lib/utils/filelock.py \
307 f21bb4b7 Michael Hanselmann
	lib/utils/hash.py \
308 3865ca48 Michael Hanselmann
	lib/utils/io.py \
309 1ae4c5a1 Michael Hanselmann
	lib/utils/log.py \
310 8dc76d54 Guido Trotter
	lib/utils/mlock.py \
311 17b97ab3 Michael Hanselmann
	lib/utils/nodesetup.py \
312 a4ccecf6 Michael Hanselmann
	lib/utils/process.py \
313 7fcffe27 Michael Hanselmann
	lib/utils/retry.py \
314 7831fc5f Michael Hanselmann
	lib/utils/text.py \
315 c50645c0 Michael Hanselmann
	lib/utils/wrapper.py \
316 c50645c0 Michael Hanselmann
	lib/utils/x509.py
317 c047a981 Michael Hanselmann
318 f05c99f3 Michael Hanselmann
docrst = \
319 ffa6869f Iustin Pop
	doc/admin.rst \
320 5c0c1eeb Iustin Pop
	doc/design-2.0.rst \
321 4f366caf Michael Hanselmann
	doc/design-2.1.rst \
322 e56bb0e8 Guido Trotter
	doc/design-2.2.rst \
323 1eb85930 Guido Trotter
	doc/design-2.3.rst \
324 92902e91 Iustin Pop
	doc/design-htools-2.3.rst \
325 78b40c5e Michael Hanselmann
	doc/design-2.4.rst \
326 d774ce92 Michael Hanselmann
	doc/design-2.5.rst \
327 c95c0f71 Michael Hanselmann
	doc/design-draft.rst \
328 1e86ee97 Marc Schmitt
	doc/design-oob.rst \
329 ae9b5e0f Tsachy Shacham
	doc/design-cpu-pinning.rst \
330 e5a246df Michael Hanselmann
	doc/design-query2.rst \
331 539f195a Michael Hanselmann
	doc/design-x509-ca.rst \
332 278ddaa9 Michael Hanselmann
	doc/design-http-server.rst \
333 1375e1d9 Michael Hanselmann
	doc/design-impexp2.rst \
334 ed9fda24 Michael Hanselmann
	doc/design-lu-generated-jobs.rst \
335 4055b109 Adeodato Simo
	doc/design-multi-reloc.rst \
336 eec83a95 Apollon Oikonomopoulos
	doc/design-network.rst \
337 6c3d18e0 Michael Hanselmann
	doc/design-chained-jobs.rst \
338 64ea845e Michael Hanselmann
	doc/design-ovf-support.rst \
339 d85f01e7 Iustin Pop
	doc/design-resource-model.rst \
340 d9bdffc3 René Nussbaumer
	doc/cluster-merge.rst \
341 a997cec5 Apollon Oikonomopoulos
	doc/design-shared-storage.rst \
342 23f0b93e René Nussbaumer
	doc/design-node-state-cache.rst \
343 6b898285 Iustin Pop
	doc/design-virtual-clusters.rst \
344 a47dc554 René Nussbaumer
	doc/design-query-splitting.rst \
345 62947ebb Michael Hanselmann
	doc/devnotes.rst \
346 e2078d28 Iustin Pop
	doc/glossary.rst \
347 4d6443f4 Iustin Pop
	doc/hooks.rst \
348 876860a3 Iustin Pop
	doc/iallocator.rst \
349 d17e74b4 Iustin Pop
	doc/index.rst \
350 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
351 28e15341 Iustin Pop
	doc/install.rst \
352 9725b53d Michael Hanselmann
	doc/locking.rst \
353 6bf273d5 Michael Hanselmann
	doc/move-instance.rst \
354 c71a1a3d Iustin Pop
	doc/news.rst \
355 a47dc554 René Nussbaumer
	doc/ovfconverter.rst \
356 6d81475c Iustin Pop
	doc/rapi.rst \
357 b76aac08 Michael Hanselmann
	doc/security.rst \
358 35dd762d Michael Hanselmann
	doc/upgrade.rst \
359 c71a1a3d Iustin Pop
	doc/walkthrough.rst
360 f05c99f3 Michael Hanselmann
361 0985325d Iustin Pop
HS_PROGS = htools/htools
362 22e513e7 Agata Murawska
HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
363 d6159933 Iustin Pop
364 73b0fa69 Iustin Pop
HS_ALL_PROGS = $(HS_PROGS) htools/test htools/hpc-htools htools/hconfd
365 c3f67183 Iustin Pop
HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
366 3096524e Iustin Pop
HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/%) test/hail
367 3096524e Iustin Pop
368 74e60746 Iustin Pop
HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
369 74e60746 Iustin Pop
# extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
370 d6159933 Iustin Pop
HEXTRA =
371 c7ec3025 Iustin Pop
# internal extra flags (used for htools/test mainly)
372 c7ec3025 Iustin Pop
HEXTRA_INT =
373 b91e9518 Iustin Pop
# exclude options for coverage reports
374 9822b1dd Iustin Pop
HPCEXCL = --exclude Main \
375 98b33d0e Iustin Pop
	--exclude Ganeti.Constants \
376 9822b1dd Iustin Pop
	--exclude Ganeti.THH \
377 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QC \
378 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QCHelper \
379 98b33d0e Iustin Pop
	--exclude Ganeti.HTools.Version
380 d6159933 Iustin Pop
381 c3f67183 Iustin Pop
HS_LIB_SRCS = \
382 d6159933 Iustin Pop
	htools/Ganeti/HTools/CLI.hs \
383 d6159933 Iustin Pop
	htools/Ganeti/HTools/Cluster.hs \
384 1adec4be Iustin Pop
	htools/Ganeti/HTools/Compat.hs \
385 d6159933 Iustin Pop
	htools/Ganeti/HTools/Container.hs \
386 d6159933 Iustin Pop
	htools/Ganeti/HTools/ExtLoader.hs \
387 d6159933 Iustin Pop
	htools/Ganeti/HTools/Group.hs \
388 d6159933 Iustin Pop
	htools/Ganeti/HTools/IAlloc.hs \
389 d6159933 Iustin Pop
	htools/Ganeti/HTools/Instance.hs \
390 f047f90f Iustin Pop
	htools/Ganeti/HTools/JSON.hs \
391 d6159933 Iustin Pop
	htools/Ganeti/HTools/Loader.hs \
392 d6159933 Iustin Pop
	htools/Ganeti/HTools/Luxi.hs \
393 d6159933 Iustin Pop
	htools/Ganeti/HTools/Node.hs \
394 d6159933 Iustin Pop
	htools/Ganeti/HTools/PeerMap.hs \
395 d6159933 Iustin Pop
	htools/Ganeti/HTools/QC.hs \
396 9822b1dd Iustin Pop
	htools/Ganeti/HTools/QCHelper.hs \
397 d6159933 Iustin Pop
	htools/Ganeti/HTools/Rapi.hs \
398 d6159933 Iustin Pop
	htools/Ganeti/HTools/Simu.hs \
399 d6159933 Iustin Pop
	htools/Ganeti/HTools/Text.hs \
400 d6159933 Iustin Pop
	htools/Ganeti/HTools/Types.hs \
401 d6159933 Iustin Pop
	htools/Ganeti/HTools/Utils.hs \
402 9f13be88 Iustin Pop
	htools/Ganeti/HTools/Program.hs \
403 458a286a Iustin Pop
	htools/Ganeti/HTools/Program/Hail.hs \
404 201b6c34 Iustin Pop
	htools/Ganeti/HTools/Program/Hbal.hs \
405 22e513e7 Agata Murawska
	htools/Ganeti/HTools/Program/Hcheck.hs \
406 2922d2c5 René Nussbaumer
	htools/Ganeti/HTools/Program/Hinfo.hs \
407 7b695a0d Iustin Pop
	htools/Ganeti/HTools/Program/Hscan.hs \
408 1494a4cc Iustin Pop
	htools/Ganeti/HTools/Program/Hspace.hs \
409 0c37d1e4 Iustin Pop
	htools/Ganeti/BasicTypes.hs \
410 417cc253 Iustin Pop
	htools/Ganeti/Confd.hs \
411 358a0a8f Iustin Pop
	htools/Ganeti/Confd/Server.hs \
412 eaa64cd8 Iustin Pop
	htools/Ganeti/Config.hs \
413 6ec7a50e Iustin Pop
	htools/Ganeti/Daemon.hs \
414 21dc8694 Iustin Pop
	htools/Ganeti/Hash.hs \
415 d6159933 Iustin Pop
	htools/Ganeti/Jobs.hs \
416 ba4e38e8 Iustin Pop
	htools/Ganeti/Logging.hs \
417 d6159933 Iustin Pop
	htools/Ganeti/Luxi.hs \
418 b1e81520 Iustin Pop
	htools/Ganeti/Objects.hs \
419 e9aaa3c6 Iustin Pop
	htools/Ganeti/OpCodes.hs \
420 7946c25d Iustin Pop
	htools/Ganeti/Runtime.hs \
421 aa3adf35 Iustin Pop
	htools/Ganeti/Ssconf.hs \
422 e9aaa3c6 Iustin Pop
	htools/Ganeti/THH.hs
423 d6159933 Iustin Pop
424 d99d1e36 Iustin Pop
HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
425 c3f67183 Iustin Pop
HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
426 d6159933 Iustin Pop
427 c964d962 Michael Hanselmann
$(RUN_IN_TEMPDIR): | $(all_dirfiles)
428 c964d962 Michael Hanselmann
429 a2d917f3 Iustin Pop
# Note: we use here an order-only prerequisite, as the contents of
430 a2d917f3 Iustin Pop
# _autoconf.py are not actually influencing the html build output: it
431 a2d917f3 Iustin Pop
# has to exist in order for the sphinx module to be loaded
432 a2d917f3 Iustin Pop
# successfully, but we certainly don't want the docs to be rebuilt if
433 a2d917f3 Iustin Pop
# it changes
434 c964d962 Michael Hanselmann
doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
435 7142485a Iustin Pop
	$(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
436 7142485a Iustin Pop
	lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
437 08366664 Michael Hanselmann
	| $(BUILT_PYTHON_SOURCES)
438 d17e74b4 Iustin Pop
	@test -n "$(SPHINX)" || \
439 d17e74b4 Iustin Pop
	    { echo 'sphinx-build' not found during configure; exit 1; }
440 2750b299 Michael Hanselmann
	@mkdir_p@ $(dir $@)
441 e7f6524c Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
442 13de7d59 Michael Hanselmann
	    -d . \
443 d17e74b4 Iustin Pop
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
444 d17e74b4 Iustin Pop
	    -D release="$(PACKAGE_VERSION)" \
445 13de7d59 Michael Hanselmann
	    $(abs_top_srcdir)/doc $(CURDIR)/doc/html
446 13de7d59 Michael Hanselmann
	rm -f doc/html/.buildinfo doc/html/objects.inv
447 13de7d59 Michael Hanselmann
	touch $@
448 13de7d59 Michael Hanselmann
449 c964d962 Michael Hanselmann
doc/html: doc/html/index.html
450 2ab2b9f5 Iustin Pop
451 cbf3d64b Michael Hanselmann
doc/install-quick.rst: INSTALL
452 b76aac08 Michael Hanselmann
doc/news.rst: NEWS
453 7a03d293 Michael Hanselmann
doc/upgrade.rst: UPGRADE
454 b76aac08 Michael Hanselmann
455 e8deef56 Michael Hanselmann
doc/install-quick.rst doc/news.rst doc/upgrade.rst:
456 cbf3d64b Michael Hanselmann
	set -e; \
457 cbf3d64b Michael Hanselmann
	{ echo '.. This file is automatically updated at build time from $<.'; \
458 cbf3d64b Michael Hanselmann
	  echo '.. Do not edit.'; \
459 cbf3d64b Michael Hanselmann
	  echo; \
460 cbf3d64b Michael Hanselmann
	  cat $<; \
461 cbf3d64b Michael Hanselmann
	} > $@
462 cbf3d64b Michael Hanselmann
463 b8195800 Iustin Pop
docdot = \
464 ca9ccea8 Michael Hanselmann
	doc/arch-2.0.dot \
465 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-acquire.dot \
466 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-release.dot
467 b8195800 Iustin Pop
468 d17e74b4 Iustin Pop
docpng = $(patsubst %.dot,%.png,$(docdot))
469 e8230860 Michael Hanselmann
470 7e1ccbe0 Michael Hanselmann
# Things to build but not to install (add it to EXTRA_DIST if it should be
471 7e1ccbe0 Michael Hanselmann
# distributed)
472 7e1ccbe0 Michael Hanselmann
noinst_DATA = \
473 7e1ccbe0 Michael Hanselmann
	devel/upload \
474 7e1ccbe0 Michael Hanselmann
	doc/html \
475 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
476 7e1ccbe0 Michael Hanselmann
	doc/examples/bash_completion \
477 7e1ccbe0 Michael Hanselmann
	$(manhtml)
478 f29266b4 Iustin Pop
479 4f3d5b76 Michael Hanselmann
gnt_scripts = \
480 e8230860 Michael Hanselmann
	scripts/gnt-backup \
481 e8230860 Michael Hanselmann
	scripts/gnt-cluster \
482 e8230860 Michael Hanselmann
	scripts/gnt-debug \
483 667dbd6b Adeodato Simo
	scripts/gnt-group \
484 e8230860 Michael Hanselmann
	scripts/gnt-instance \
485 e8230860 Michael Hanselmann
	scripts/gnt-job \
486 e8230860 Michael Hanselmann
	scripts/gnt-node \
487 9bcef16f Constantinos Venetsanopoulos
	scripts/gnt-os \
488 9bcef16f Constantinos Venetsanopoulos
	scripts/gnt-storage
489 e8230860 Michael Hanselmann
490 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP_SBIN = \
491 29d91329 Michael Hanselmann
	daemons/ganeti-masterd \
492 5119f2ec Michael Hanselmann
	daemons/ganeti-noded \
493 9f4bb951 Michael Hanselmann
	daemons/ganeti-watcher \
494 d9c82a4e Michael Hanselmann
	daemons/ganeti-rapi \
495 656a7fdf Iustin Pop
	$(gnt_scripts)
496 2d48a3a2 Michael Hanselmann
497 73b0fa69 Iustin Pop
if PY_CONFD
498 73b0fa69 Iustin Pop
PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
499 73b0fa69 Iustin Pop
endif
500 73b0fa69 Iustin Pop
501 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP = \
502 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
503 0d2bf835 René Nussbaumer
	tools/ensure-dirs
504 0d2bf835 René Nussbaumer
505 a8c68e44 Michael Hanselmann
qa_scripts = \
506 a0c3e726 Michael Hanselmann
	qa/__init__.py \
507 a8c68e44 Michael Hanselmann
	qa/ganeti-qa.py \
508 a8c68e44 Michael Hanselmann
	qa/qa_cluster.py \
509 a8c68e44 Michael Hanselmann
	qa/qa_config.py \
510 a8c68e44 Michael Hanselmann
	qa/qa_daemon.py \
511 a8c68e44 Michael Hanselmann
	qa/qa_env.py \
512 a8c68e44 Michael Hanselmann
	qa/qa_error.py \
513 21bf2e2e Andrea Spadaccini
	qa/qa_group.py \
514 a8c68e44 Michael Hanselmann
	qa/qa_instance.py \
515 09470dd8 Michael Hanselmann
	qa/qa_job.py \
516 a8c68e44 Michael Hanselmann
	qa/qa_node.py \
517 a8c68e44 Michael Hanselmann
	qa/qa_os.py \
518 a8c68e44 Michael Hanselmann
	qa/qa_rapi.py \
519 a8c68e44 Michael Hanselmann
	qa/qa_tags.py \
520 a8c68e44 Michael Hanselmann
	qa/qa_utils.py
521 a8c68e44 Michael Hanselmann
522 d6159933 Iustin Pop
bin_SCRIPTS =
523 d6159933 Iustin Pop
if WANT_HTOOLS
524 c3f67183 Iustin Pop
bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
525 458a286a Iustin Pop
install-exec-hook:
526 458a286a Iustin Pop
	@mkdir_p@ $(DESTDIR)$(iallocatorsdir)
527 7fa52acd Iustin Pop
# FIXME: this is a hardcoded logic, instead of auto-resolving
528 7fa52acd Iustin Pop
	$(LN_S) -f ../../../bin/htools \
529 458a286a Iustin Pop
		   $(DESTDIR)$(iallocatorsdir)/hail
530 201b6c34 Iustin Pop
	for role in $(HS_BIN_ROLES); do \
531 7fa52acd Iustin Pop
		$(LN_S) -f htools \
532 201b6c34 Iustin Pop
			   $(DESTDIR)$(bindir)/$$role ; \
533 201b6c34 Iustin Pop
	done
534 73b0fa69 Iustin Pop
if HS_CONFD
535 73b0fa69 Iustin Pop
	mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
536 73b0fa69 Iustin Pop
endif
537 d6159933 Iustin Pop
endif
538 d6159933 Iustin Pop
539 c3f67183 Iustin Pop
$(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
540 16a6192d Iustin Pop
	@if [ -z "$(HTOOLS)" ]; then \
541 16a6192d Iustin Pop
	  echo "Error: htools compilation disabled at configure time" 1>&2 ;\
542 16a6192d Iustin Pop
	  exit 1; \
543 16a6192d Iustin Pop
	fi
544 49e11c49 Iustin Pop
	@BINARY=$(@:htools/%=%); \
545 49e11c49 Iustin Pop
	if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
546 fd0bc853 Iustin Pop
	  echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
547 fd0bc853 Iustin Pop
	  exit 1; \
548 49e11c49 Iustin Pop
	fi
549 a593113c Iustin Pop
	rm -f $(@:htools/%=%).tix
550 49e11c49 Iustin Pop
	BINARY=$(@:htools/%=%); $(GHC) --make \
551 ef958f2a Iustin Pop
	  $(HFLAGS) \
552 1adec4be Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
553 ef958f2a Iustin Pop
	  -osuf $$BINARY.o -hisuf $$BINARY.hi \
554 c7ec3025 Iustin Pop
	  $(HEXTRA) $(HEXTRA_INT) $@
555 70b6c284 Iustin Pop
	@touch "$@"
556 70b6c284 Iustin Pop
557 b91e9518 Iustin Pop
# for the htools/test binary, we need to enable profiling/coverage
558 c7ec3025 Iustin Pop
htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
559 b91e9518 Iustin Pop
	-fno-warn-monomorphism-restriction -fno-warn-orphans \
560 b91e9518 Iustin Pop
	-fno-warn-missing-methods -fno-warn-unused-imports
561 b91e9518 Iustin Pop
562 896b2850 Iustin Pop
# we compile the hpc-htools binary with the program coverage
563 896b2850 Iustin Pop
htools/hpc-htools: HEXTRA_INT=-fhpc
564 25cdf177 Iustin Pop
565 04d15e63 Iustin Pop
# test dependency
566 896b2850 Iustin Pop
htools/offline-tests.sh: htools/hpc-htools
567 04d15e63 Iustin Pop
568 c7ec3025 Iustin Pop
# rules for building profiling-enabled versions of the haskell
569 c7ec3025 Iustin Pop
# programs: hs-prof does the full two-step build, whereas
570 c7ec3025 Iustin Pop
# hs-prof-quick does only the final rebuild (hs-prof must have been
571 c7ec3025 Iustin Pop
# run before)
572 c7ec3025 Iustin Pop
.PHONY: hs-prof hs-prof-quick
573 c7ec3025 Iustin Pop
hs-prof:
574 c7ec3025 Iustin Pop
	$(MAKE) clean
575 c7ec3025 Iustin Pop
	$(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
576 c7ec3025 Iustin Pop
	rm -f $(HS_ALL_PROGS)
577 c7ec3025 Iustin Pop
	$(MAKE) hs-prof-quick
578 c7ec3025 Iustin Pop
579 c7ec3025 Iustin Pop
hs-prof-quick:
580 c7ec3025 Iustin Pop
	$(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
581 c7ec3025 Iustin Pop
582 da7e44ee Michael Hanselmann
dist_sbin_SCRIPTS = \
583 da7e44ee Michael Hanselmann
	tools/ganeti-listrunner
584 4f3d5b76 Michael Hanselmann
585 fc3fd894 Michael Hanselmann
nodist_sbin_SCRIPTS = \
586 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
587 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner
588 fc3fd894 Michael Hanselmann
589 73b0fa69 Iustin Pop
if HS_CONFD
590 73b0fa69 Iustin Pop
nodist_sbin_SCRIPTS += htools/hconfd
591 73b0fa69 Iustin Pop
endif
592 73b0fa69 Iustin Pop
593 cc120286 Bernardo Dal Seno
python_scripts = \
594 e8230860 Michael Hanselmann
	tools/burnin \
595 e8230860 Michael Hanselmann
	tools/cfgshell \
596 e8230860 Michael Hanselmann
	tools/cfgupgrade \
597 b5672ea0 Iustin Pop
	tools/cfgupgrade12 \
598 1f7d3f7d René Nussbaumer
	tools/cluster-merge \
599 4ef0399b Iustin Pop
	tools/confd-client \
600 d62cbd3a Michael Hanselmann
	tools/fmtjson \
601 ea5fd476 Iustin Pop
	tools/lvmstrap \
602 6bf273d5 Michael Hanselmann
	tools/move-instance \
603 ced78a66 Agata Murawska
	tools/ovfconverter \
604 05cd934d René Nussbaumer
	tools/setup-ssh \
605 ea5fd476 Iustin Pop
	tools/sanitize-config
606 e8230860 Michael Hanselmann
607 61631293 Stephen Shirley
dist_tools_SCRIPTS = \
608 cc120286 Bernardo Dal Seno
	$(python_scripts) \
609 2f4c951e Stephen Shirley
	tools/kvm-console-wrapper \
610 d9eefcfa Andrea Spadaccini
	tools/xm-console-wrapper \
611 d9eefcfa Andrea Spadaccini
	tools/master-ip-setup
612 61631293 Stephen Shirley
613 2d76b580 Michael Hanselmann
pkglib_python_scripts = \
614 c6ccba7e Michael Hanselmann
	daemons/import-export \
615 c6ccba7e Michael Hanselmann
	tools/check-cert-expired
616 2d76b580 Michael Hanselmann
617 0d2bf835 René Nussbaumer
nodist_pkglib_python_scripts = \
618 0d2bf835 René Nussbaumer
	tools/ensure-dirs
619 0d2bf835 René Nussbaumer
620 b8fe7ca6 Iustin Pop
myexeclib_SCRIPTS = \
621 2d76b580 Michael Hanselmann
	daemons/daemon-util \
622 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
623 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts)
624 f154a7a3 Michael Hanselmann
625 b8fe7ca6 Iustin Pop
nodist_myexeclib_SCRIPTS = \
626 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts)
627 0d2bf835 René Nussbaumer
628 e8230860 Michael Hanselmann
EXTRA_DIST = \
629 e8230860 Michael Hanselmann
	NEWS \
630 7a03d293 Michael Hanselmann
	UPGRADE \
631 f774bd03 Michael Hanselmann
	epydoc.conf.in \
632 70c771f6 Michael Hanselmann
	pylintrc \
633 bb46a96c Michael Hanselmann
	autotools/build-bash-completion \
634 d5a2a550 Michael Hanselmann
	autotools/build-rpc \
635 5d3c30df Michael Hanselmann
	autotools/check-header \
636 eed5c5df Michael Hanselmann
	autotools/check-python-code \
637 f6cbcc06 Michael Hanselmann
	autotools/check-imports \
638 c55cc346 Iustin Pop
	autotools/check-man-dashes \
639 73d0e218 Iustin Pop
	autotools/check-man-warnings \
640 c81ed2b2 Michael Hanselmann
	autotools/check-news \
641 e627fe09 Michael Hanselmann
	autotools/check-tar \
642 96602be4 Michael Hanselmann
	autotools/check-version \
643 d99d1e36 Iustin Pop
	autotools/convert-constants \
644 95eb4188 Michael Hanselmann
	autotools/docpp \
645 27e336af Michael Hanselmann
	autotools/gen-coverage \
646 df69e0a0 Bernardo Dal Seno
	autotools/testrunner \
647 387863a5 Iustin Pop
	autotools/wrong-hardcoded-paths \
648 f3313af5 Guido Trotter
	$(RUN_IN_TEMPDIR) \
649 f154a7a3 Michael Hanselmann
	daemons/daemon-util.in \
650 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner.in \
651 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
652 e8230860 Michael Hanselmann
	devel/upload.in \
653 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup.in \
654 b8195800 Iustin Pop
	$(docdot) \
655 f727d134 Michael Hanselmann
	$(docpng) \
656 d17e74b4 Iustin Pop
	$(docrst) \
657 d17e74b4 Iustin Pop
	doc/conf.py \
658 d17e74b4 Iustin Pop
	doc/html \
659 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES:%=%.in) \
660 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default \
661 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default-debug \
662 d6d9ce45 Guido Trotter
	doc/examples/hooks/ethers \
663 89c04c2d Guido Trotter
	doc/examples/gnt-debug/README \
664 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay0.json \
665 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay50.json \
666 e4d452b4 Michael Hanselmann
	test/lockperf.py \
667 e8230860 Michael Hanselmann
	test/testutils.py \
668 e8230860 Michael Hanselmann
	test/mocks.py \
669 e8230860 Michael Hanselmann
	$(dist_TESTS) \
670 e8230860 Michael Hanselmann
	$(TEST_FILES) \
671 6be8e2bf Iustin Pop
	man/footer.rst \
672 6be8e2bf Iustin Pop
	$(manrst) \
673 f727d134 Michael Hanselmann
	$(maninput) \
674 39e0d19e Michael Hanselmann
	qa/qa-sample.json \
675 d6159933 Iustin Pop
	$(qa_scripts) \
676 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
677 5a1e31b4 Iustin Pop
	$(HS_PROG_SRCS) \
678 04d15e63 Iustin Pop
	htools/lint-hints.hs \
679 04d15e63 Iustin Pop
	htools/cli-tests-defs.sh \
680 04d15e63 Iustin Pop
	htools/offline-test.sh
681 e8230860 Michael Hanselmann
682 e8230860 Michael Hanselmann
man_MANS = \
683 e8230860 Michael Hanselmann
	man/ganeti.7 \
684 bae7e531 Michael Hanselmann
	man/ganeti-cleaner.8 \
685 b7b7cda6 Guido Trotter
	man/ganeti-confd.8 \
686 da7e44ee Michael Hanselmann
	man/ganeti-listrunner.8 \
687 320d986d Iustin Pop
	man/ganeti-masterd.8 \
688 e8230860 Michael Hanselmann
	man/ganeti-noded.8 \
689 e8230860 Michael Hanselmann
	man/ganeti-os-interface.7 \
690 7c88c7af Constantinos Venetsanopoulos
	man/ganeti-extstorage-interface.7 \
691 320d986d Iustin Pop
	man/ganeti-rapi.8 \
692 e8230860 Michael Hanselmann
	man/ganeti-watcher.8 \
693 e8230860 Michael Hanselmann
	man/gnt-backup.8 \
694 e8230860 Michael Hanselmann
	man/gnt-cluster.8 \
695 d3b4cf9f Iustin Pop
	man/gnt-debug.8 \
696 667dbd6b Adeodato Simo
	man/gnt-group.8 \
697 e8230860 Michael Hanselmann
	man/gnt-instance.8 \
698 d3b4cf9f Iustin Pop
	man/gnt-job.8 \
699 e8230860 Michael Hanselmann
	man/gnt-node.8 \
700 5a19bd35 Iustin Pop
	man/gnt-os.8 \
701 7c88c7af Constantinos Venetsanopoulos
	man/gnt-storage.8 \
702 5a19bd35 Iustin Pop
	man/hail.1 \
703 5a19bd35 Iustin Pop
	man/hbal.1 \
704 f18e4168 Iustin Pop
	man/hcheck.1 \
705 e2bdaf25 René Nussbaumer
	man/hinfo.1 \
706 5a19bd35 Iustin Pop
	man/hscan.1 \
707 d26d808a Iustin Pop
	man/hspace.1 \
708 d26d808a Iustin Pop
	man/htools.1
709 e8230860 Michael Hanselmann
710 5a19bd35 Iustin Pop
manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
711 6be8e2bf Iustin Pop
manhtml = $(patsubst %.rst,%.html,$(manrst))
712 fcdb582d Michael Hanselmann
mangen = $(patsubst %.rst,%.gen,$(manrst))
713 25c92bc5 Michael Hanselmann
maninput = \
714 5a19bd35 Iustin Pop
	$(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
715 de8eea3e Iustin Pop
	$(patsubst %.html,%.html.in,$(manhtml)) \
716 fcdb582d Michael Hanselmann
	man/footer.man man/footer.html $(mangen)
717 e8230860 Michael Hanselmann
718 e8230860 Michael Hanselmann
TEST_FILES = \
719 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.0.txt \
720 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.3.txt \
721 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-disk.txt \
722 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip4.txt \
723 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip6.txt \
724 27e46076 Michael Hanselmann
	test/data/cert1.pem \
725 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-dummy0.txt \
726 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv4.txt \
727 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv6.txt \
728 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv4.txt \
729 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv6.txt \
730 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline.txt \
731 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo.txt \
732 d816408a Iustin Pop
	test/data/proc_drbd8.txt \
733 a6ac80db Iustin Pop
	test/data/proc_drbd80-emptyline.txt \
734 2d76b580 Michael Hanselmann
	test/data/proc_drbd83.txt \
735 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync.txt \
736 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync_krnl2.6.39.txt \
737 585c8187 Guido Trotter
	test/data/kvm_1.0_help.txt \
738 585c8187 Guido Trotter
	test/data/kvm_0.15.90_help.txt \
739 585c8187 Guido Trotter
	test/data/kvm_0.12.5_help.txt \
740 585c8187 Guido Trotter
	test/data/kvm_0.9.1_help.txt \
741 549071a0 Luca Bigliardi
	test/data/sys_drbd_usermode_helper.txt \
742 6bbd76d2 Iustin Pop
	test/data/htools/hail-alloc-drbd.json \
743 6bbd76d2 Iustin Pop
	test/data/htools/hail-change-group.json \
744 3e5012c6 Iustin Pop
	test/data/htools/hail-invalid-reloc.json \
745 6bbd76d2 Iustin Pop
	test/data/htools/hail-node-evac.json \
746 6bbd76d2 Iustin Pop
	test/data/htools/hail-reloc-drbd.json \
747 a95aa74c Iustin Pop
	test/data/htools/hbal-split-insts.data \
748 9915fb20 Iustin Pop
	test/data/htools/common-suffix.data \
749 9915fb20 Iustin Pop
	test/data/htools/invalid-node.data \
750 9915fb20 Iustin Pop
	test/data/htools/missing-resources.data \
751 55ffacfa Iustin Pop
	test/data/htools/rapi/groups.json \
752 55ffacfa Iustin Pop
	test/data/htools/rapi/info.json \
753 55ffacfa Iustin Pop
	test/data/htools/rapi/instances.json \
754 55ffacfa Iustin Pop
	test/data/htools/rapi/nodes.json \
755 1e6fab60 Agata Murawska
	test/data/ovfdata/compr_disk.vmdk.gz \
756 d92518d3 Agata Murawska
	test/data/ovfdata/config.ini \
757 1e6fab60 Agata Murawska
	test/data/ovfdata/corrupted_resources.ovf \
758 d92518d3 Agata Murawska
	test/data/ovfdata/empty.ini \
759 1e6fab60 Agata Murawska
	test/data/ovfdata/empty.ovf \
760 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.mf \
761 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.ovf \
762 1e6fab60 Agata Murawska
	test/data/ovfdata/gzip_disk.ovf \
763 1e6fab60 Agata Murawska
	test/data/ovfdata/new_disk.vmdk \
764 d92518d3 Agata Murawska
	test/data/ovfdata/no_disk.ini \
765 1e6fab60 Agata Murawska
	test/data/ovfdata/no_disk_in_ref.ovf \
766 d92518d3 Agata Murawska
	test/data/ovfdata/no_os.ini \
767 1e6fab60 Agata Murawska
	test/data/ovfdata/no_ovf.ova \
768 1e6fab60 Agata Murawska
	test/data/ovfdata/ova.ova \
769 1e6fab60 Agata Murawska
	test/data/ovfdata/second_disk.vmdk \
770 d92518d3 Agata Murawska
	test/data/ovfdata/rawdisk.raw \
771 d92518d3 Agata Murawska
	test/data/ovfdata/unsafe_path.ini \
772 1e6fab60 Agata Murawska
	test/data/ovfdata/virtualbox.ovf \
773 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_extension.ovd \
774 d92518d3 Agata Murawska
	test/data/ovfdata/wrong_config.ini \
775 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.mf \
776 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.ovf \
777 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_ova.ova \
778 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_xml.ovf \
779 d92518d3 Agata Murawska
	test/data/ovfdata/other/rawdisk.raw \
780 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.02.txt \
781 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-fail.txt \
782 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-ok.txt \
783 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.02.txt \
784 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.66.txt \
785 53d4cdf1 Iustin Pop
	test/import-export_unittest-helper \
786 30f2802f Iustin Pop
	test/gnt-cli.test \
787 30f2802f Iustin Pop
	test/ganeti-cli.test \
788 53d4cdf1 Iustin Pop
	test/htools-balancing.test \
789 53d4cdf1 Iustin Pop
	test/htools-basic.test \
790 53d4cdf1 Iustin Pop
	test/htools-dynutil.test \
791 53d4cdf1 Iustin Pop
	test/htools-excl.test \
792 53d4cdf1 Iustin Pop
	test/htools-hail.test \
793 53d4cdf1 Iustin Pop
	test/htools-hspace.test \
794 53d4cdf1 Iustin Pop
	test/htools-invalid.test \
795 53d4cdf1 Iustin Pop
	test/htools-multi-group.test \
796 53d4cdf1 Iustin Pop
	test/htools-no-backend.test \
797 53d4cdf1 Iustin Pop
	test/htools-rapi.test \
798 53d4cdf1 Iustin Pop
	test/htools-single-group.test \
799 53d4cdf1 Iustin Pop
	test/htools-text-backend.test
800 e8230860 Michael Hanselmann
801 e8c8cf1a Michael Hanselmann
python_tests = \
802 3ade0e0e Michael Hanselmann
	doc/examples/rapi_testutils.py \
803 17496050 Guido Trotter
	test/ganeti.asyncnotifier_unittest.py \
804 f942a838 Michael Hanselmann
	test/ganeti.backend_unittest.py \
805 6de7c41d Iustin Pop
	test/ganeti.bdev_unittest.py \
806 6de7c41d Iustin Pop
	test/ganeti.cli_unittest.py \
807 66d1f035 René Nussbaumer
	test/ganeti.client.gnt_cluster_unittest.py \
808 25ce3ec4 Michael Hanselmann
	test/ganeti.client.gnt_instance_unittest.py \
809 1118ec44 Guido Trotter
	test/ganeti.daemon_unittest.py \
810 6de7c41d Iustin Pop
	test/ganeti.cmdlib_unittest.py \
811 cea881e5 Michael Hanselmann
	test/ganeti.compat_unittest.py \
812 edf7d66e Iustin Pop
	test/ganeti.confd.client_unittest.py \
813 e8230860 Michael Hanselmann
	test/ganeti.config_unittest.py \
814 6de7c41d Iustin Pop
	test/ganeti.constants_unittest.py \
815 3bd19c66 Michael Hanselmann
	test/ganeti.errors_unittest.py \
816 e8230860 Michael Hanselmann
	test/ganeti.hooks_unittest.py \
817 ecdf0398 Michael Hanselmann
	test/ganeti.ht_unittest.py \
818 6de7c41d Iustin Pop
	test/ganeti.http_unittest.py \
819 b7d82e40 Iustin Pop
	test/ganeti.hypervisor_unittest.py \
820 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_chroot_unittest.py \
821 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_fake_unittest.py \
822 748e4b5a Michael Hanselmann
	test/ganeti.hypervisor.hv_kvm_unittest.py \
823 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_lxc_unittest.py \
824 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_xen_unittest.py \
825 bb44b1ae Michael Hanselmann
	test/ganeti.impexpd_unittest.py \
826 989a8bee Michael Hanselmann
	test/ganeti.jqueue_unittest.py \
827 e8230860 Michael Hanselmann
	test/ganeti.locking_unittest.py \
828 231db3a5 Michael Hanselmann
	test/ganeti.luxi_unittest.py \
829 033a1d00 Michael Hanselmann
	test/ganeti.masterd.instance_unittest.py \
830 407339d0 Michael Hanselmann
	test/ganeti.mcpu_unittest.py \
831 a744b676 Manuel Franceschini
	test/ganeti.netutils_unittest.py \
832 4c14965f Guido Trotter
	test/ganeti.objects_unittest.py \
833 c32b908e Michael Hanselmann
	test/ganeti.opcodes_unittest.py \
834 1e6fab60 Agata Murawska
	test/ganeti.ovf_unittest.py \
835 a123dc19 Michael Hanselmann
	test/ganeti.qlang_unittest.py \
836 4ca96421 Michael Hanselmann
	test/ganeti.query_unittest.py \
837 cfaeaaf7 Michael Hanselmann
	test/ganeti.rapi.baserlib_unittest.py \
838 95ab4de9 David Knowles
	test/ganeti.rapi.client_unittest.py \
839 4cbd4462 Oleksiy Mishchenko
	test/ganeti.rapi.resources_unittest.py \
840 6395cebb Michael Hanselmann
	test/ganeti.rapi.rlib2_unittest.py \
841 a85f23fa Michael Hanselmann
	test/ganeti.rapi.testutils_unittest.py \
842 33231500 Michael Hanselmann
	test/ganeti.rpc_unittest.py \
843 f12e1736 René Nussbaumer
	test/ganeti.runtime_unittest.py \
844 6de7c41d Iustin Pop
	test/ganeti.serializer_unittest.py \
845 6de7c41d Iustin Pop
	test/ganeti.ssh_unittest.py \
846 048eeb2b Iustin Pop
	test/ganeti.storage_unittest.py \
847 0d2bf835 René Nussbaumer
	test/ganeti.tools.ensure_dirs_unittest.py \
848 93be53da Balazs Lecz
	test/ganeti.uidpool_unittest.py \
849 4fd029cf Michael Hanselmann
	test/ganeti.utils.algo_unittest.py \
850 9d1b963f Michael Hanselmann
	test/ganeti.utils.filelock_unittest.py \
851 f21bb4b7 Michael Hanselmann
	test/ganeti.utils.hash_unittest.py \
852 3865ca48 Michael Hanselmann
	test/ganeti.utils.io_unittest.py \
853 b6fa9a44 Michael Hanselmann
	test/ganeti.utils.log_unittest.py \
854 8dc76d54 Guido Trotter
	test/ganeti.utils.mlock_unittest.py \
855 17b97ab3 Michael Hanselmann
	test/ganeti.utils.nodesetup_unittest.py \
856 a4ccecf6 Michael Hanselmann
	test/ganeti.utils.process_unittest.py \
857 79d22269 Michael Hanselmann
	test/ganeti.utils.retry_unittest.py \
858 7fcffe27 Michael Hanselmann
	test/ganeti.utils.text_unittest.py \
859 7831fc5f Michael Hanselmann
	test/ganeti.utils.wrapper_unittest.py \
860 c50645c0 Michael Hanselmann
	test/ganeti.utils.x509_unittest.py \
861 4fd029cf Michael Hanselmann
	test/ganeti.utils_unittest.py \
862 3f991867 Michael Hanselmann
	test/ganeti.workerpool_unittest.py \
863 a0c3e726 Michael Hanselmann
	test/qa.qa_config_unittest.py \
864 aefbe369 Michael Hanselmann
	test/cfgupgrade_unittest.py \
865 055f822b Michael Hanselmann
	test/docs_unittest.py \
866 4fd2660d Michael Hanselmann
	test/pycurl_reset_unittest.py \
867 055f822b Michael Hanselmann
	test/tempfile_fork_unittest.py
868 0d20cc42 Bernardo Dal Seno
if HAS_FAKEROOT
869 0d20cc42 Bernardo Dal Seno
python_tests += test/ganeti.utils.io_unittest-runasroot.py
870 0d20cc42 Bernardo Dal Seno
endif
871 e8230860 Michael Hanselmann
872 b91e9518 Iustin Pop
haskell_tests = htools/test
873 b91e9518 Iustin Pop
874 e8c8cf1a Michael Hanselmann
dist_TESTS = \
875 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
876 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
877 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
878 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
879 30f2802f Iustin Pop
	test/cli-test.bash \
880 e8c8cf1a Michael Hanselmann
	$(python_tests)
881 e8c8cf1a Michael Hanselmann
882 e8230860 Michael Hanselmann
nodist_TESTS =
883 d3cd5a3f Iustin Pop
check_SCRIPTS =
884 d3cd5a3f Iustin Pop
885 e5f6768c Iustin Pop
if WANT_HTOOLSTESTS
886 b91e9518 Iustin Pop
nodist_TESTS += $(haskell_tests)
887 04d15e63 Iustin Pop
dist_TESTS += htools/offline-test.sh
888 3096524e Iustin Pop
check_SCRIPTS += htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
889 b91e9518 Iustin Pop
endif
890 e8230860 Michael Hanselmann
891 e8230860 Michael Hanselmann
TESTS = $(dist_TESTS) $(nodist_TESTS)
892 e8230860 Michael Hanselmann
893 27e336af Michael Hanselmann
# Environment for all tests
894 27e336af Michael Hanselmann
PLAIN_TESTS_ENVIRONMENT = \
895 30f2802f Iustin Pop
	PYTHONPATH=. \
896 30f2802f Iustin Pop
	TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
897 30f2802f Iustin Pop
	PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
898 30f2802f Iustin Pop
	$(RUN_IN_TEMPDIR)
899 27e336af Michael Hanselmann
900 27e336af Michael Hanselmann
# Environment for tests run by automake
901 f848ac00 Michael Hanselmann
TESTS_ENVIRONMENT = \
902 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
903 6e06b36c Iustin Pop
904 eed5c5df Michael Hanselmann
all_python_code = \
905 01a3a718 Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
906 cc120286 Bernardo Dal Seno
	$(python_scripts) \
907 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
908 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts) \
909 e8c8cf1a Michael Hanselmann
	$(python_tests) \
910 01a3a718 Michael Hanselmann
	$(pkgpython_PYTHON) \
911 2d48a3a2 Michael Hanselmann
	$(client_PYTHON) \
912 01a3a718 Michael Hanselmann
	$(hypervisor_PYTHON) \
913 01a3a718 Michael Hanselmann
	$(rapi_PYTHON) \
914 899c4d2c Michael Hanselmann
	$(server_PYTHON) \
915 0d2bf835 René Nussbaumer
	$(pytools_PYTHON) \
916 01a3a718 Michael Hanselmann
	$(http_PYTHON) \
917 01a3a718 Michael Hanselmann
	$(confd_PYTHON) \
918 dc101ecc Michael Hanselmann
	$(masterd_PYTHON) \
919 bb44b1ae Michael Hanselmann
	$(impexpd_PYTHON) \
920 c047a981 Michael Hanselmann
	$(utils_PYTHON) \
921 9f4bb951 Michael Hanselmann
	$(watcher_PYTHON) \
922 a8c68e44 Michael Hanselmann
	$(noinst_PYTHON) \
923 a8c68e44 Michael Hanselmann
	$(qa_scripts)
924 01a3a718 Michael Hanselmann
925 eed5c5df Michael Hanselmann
srclink_files = \
926 6be8e2bf Iustin Pop
	man/footer.rst \
927 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
928 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
929 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
930 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
931 30f2802f Iustin Pop
	test/cli-test.bash \
932 04d15e63 Iustin Pop
	htools/offline-test.sh \
933 d3cd5a3f Iustin Pop
	htools/cli-tests-defs.sh \
934 d6159933 Iustin Pop
	$(all_python_code) \
935 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_PROG_SRCS)
936 eed5c5df Michael Hanselmann
937 eed5c5df Michael Hanselmann
check_python_code = \
938 e4e7c7df Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
939 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
940 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
941 95eb4188 Michael Hanselmann
	$(DOCPP) \
942 eed5c5df Michael Hanselmann
	$(all_python_code)
943 eed5c5df Michael Hanselmann
944 e4e7c7df Michael Hanselmann
lint_python_code = \
945 f60d352e Michael Hanselmann
	ganeti \
946 f1763373 Iustin Pop
	ganeti/http/server.py \
947 f60d352e Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
948 cc120286 Bernardo Dal Seno
	$(python_scripts) \
949 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
950 2cc8bdd0 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
951 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
952 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
953 95eb4188 Michael Hanselmann
	$(DOCPP) \
954 2cc8bdd0 Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
955 eed5c5df Michael Hanselmann
956 f6cbcc06 Michael Hanselmann
standalone_python_modules = \
957 f6cbcc06 Michael Hanselmann
	lib/rapi/client.py \
958 f6cbcc06 Michael Hanselmann
	tools/ganeti-listrunner
959 f6cbcc06 Michael Hanselmann
960 21bf2e2e Andrea Spadaccini
pep8_python_code = \
961 21bf2e2e Andrea Spadaccini
	ganeti \
962 21bf2e2e Andrea Spadaccini
	ganeti/http/server.py \
963 21bf2e2e Andrea Spadaccini
	$(dist_sbin_SCRIPTS) \
964 cc120286 Bernardo Dal Seno
	$(python_scripts) \
965 21bf2e2e Andrea Spadaccini
	$(pkglib_python_scripts) \
966 21bf2e2e Andrea Spadaccini
	$(BUILD_BASH_COMPLETION) \
967 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
968 21bf2e2e Andrea Spadaccini
	$(DOCPP) \
969 21bf2e2e Andrea Spadaccini
	$(PYTHON_BOOTSTRAP) \
970 21bf2e2e Andrea Spadaccini
	qa
971 21bf2e2e Andrea Spadaccini
972 571b34f8 Michael Hanselmann
test/daemon-util_unittest.bash: daemons/daemon-util
973 571b34f8 Michael Hanselmann
974 7172f605 Michael Hanselmann
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
975 7172f605 Michael Hanselmann
976 26916aad Apollon Oikonomopoulos
tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
977 26916aad Apollon Oikonomopoulos
	sed -f $(REPLACE_VARS_SED) < $< > $@
978 26916aad Apollon Oikonomopoulos
	chmod +x $@
979 26916aad Apollon Oikonomopoulos
980 dbefcc7e Michael Hanselmann
devel/upload: devel/upload.in $(REPLACE_VARS_SED)
981 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
982 e8230860 Michael Hanselmann
	chmod u+x $@
983 e8230860 Michael Hanselmann
984 c964d962 Michael Hanselmann
daemons/%: daemons/%.in $(REPLACE_VARS_SED)
985 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
986 5c566e17 Michael Hanselmann
	chmod +x $@
987 e8230860 Michael Hanselmann
988 c964d962 Michael Hanselmann
doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
989 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
990 e8230860 Michael Hanselmann
991 c964d962 Michael Hanselmann
doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
992 a2442bf9 Luca Bigliardi
	sed -f $(REPLACE_VARS_SED) < $< > $@
993 a2442bf9 Luca Bigliardi
994 b959138f Michael Hanselmann
doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
995 88a6ca6f Michael Hanselmann
	lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
996 b959138f Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
997 4f3d5b76 Michael Hanselmann
998 f86e82ef Iustin Pop
doc/%.png: doc/%.dot
999 2ab2b9f5 Iustin Pop
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1000 f86e82ef Iustin Pop
	$(DOT) -Tpng -o $@ $<
1001 f86e82ef Iustin Pop
1002 de8eea3e Iustin Pop
man/footer.man: man/footer.rst
1003 de8eea3e Iustin Pop
	@test -n "$(PANDOC)" || \
1004 de8eea3e Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1005 de8eea3e Iustin Pop
	$(PANDOC) -f rst -t man -o $@ $<
1006 de8eea3e Iustin Pop
1007 6be8e2bf Iustin Pop
man/footer.html: man/footer.rst
1008 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1009 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1010 6be8e2bf Iustin Pop
	$(PANDOC) -f rst -t html -o $@ $<
1011 6be8e2bf Iustin Pop
1012 7142485a Iustin Pop
man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1013 d7772efa Iustin Pop
	lib/build/shell_example_lexer.py \
1014 a13d6911 Iustin Pop
	| $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1015 387863a5 Iustin Pop
	@echo "Checking $< for hardcoded paths..."
1016 387863a5 Iustin Pop
	@if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1017 387863a5 Iustin Pop
	  echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1018 387863a5 Iustin Pop
	  exit 1; \
1019 387863a5 Iustin Pop
	fi
1020 a13d6911 Iustin Pop
	set -e ; \
1021 a13d6911 Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1022 a13d6911 Iustin Pop
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1023 a13d6911 Iustin Pop
	trap - EXIT
1024 fcdb582d Michael Hanselmann
1025 5a19bd35 Iustin Pop
man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1026 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1027 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1028 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1029 9c45babb Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1030 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1031 9c45babb Iustin Pop
	  sed -e 's/\\@/@/g' > $@; \
1032 73d0e218 Iustin Pop
	if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1033 c55cc346 Iustin Pop
	$(CHECK_MAN_DASHES) $@; \
1034 9c45babb Iustin Pop
	trap - EXIT
1035 9c45babb Iustin Pop
1036 2ab2b9f5 Iustin Pop
1037 fcdb582d Michael Hanselmann
man/%.html.in: man/%.gen man/footer.html
1038 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1039 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1040 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1041 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1042 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
1043 6be8e2bf Iustin Pop
1044 5a19bd35 Iustin Pop
man/%.1: man/%.1.in $(REPLACE_VARS_SED)
1045 5a19bd35 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1046 5a19bd35 Iustin Pop
1047 dbefcc7e Michael Hanselmann
man/%.7: man/%.7.in $(REPLACE_VARS_SED)
1048 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1049 e8230860 Michael Hanselmann
1050 dbefcc7e Michael Hanselmann
man/%.8: man/%.8.in $(REPLACE_VARS_SED)
1051 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1052 e8230860 Michael Hanselmann
1053 dbefcc7e Michael Hanselmann
man/%.html: man/%.html.in $(REPLACE_VARS_SED)
1054 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1055 f29266b4 Iustin Pop
1056 75f76703 Michael Hanselmann
epydoc.conf: epydoc.conf.in Makefile
1057 75f76703 Michael Hanselmann
	sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
1058 f774bd03 Michael Hanselmann
1059 84a12e40 Iustin Pop
vcs-version:
1060 84a12e40 Iustin Pop
	if test -d .git; then \
1061 84a12e40 Iustin Pop
	  git describe > $@; \
1062 84a12e40 Iustin Pop
	elif test ! -f $@ ; then \
1063 84a12e40 Iustin Pop
	  echo "Cannot auto-generate $@ file"; exit 1; \
1064 84a12e40 Iustin Pop
	fi
1065 84a12e40 Iustin Pop
1066 316dc1ff Iustin Pop
.PHONY: clean-vcs-version
1067 316dc1ff Iustin Pop
clean-vcs-version:
1068 316dc1ff Iustin Pop
	rm -f vcs-version
1069 316dc1ff Iustin Pop
1070 84a12e40 Iustin Pop
.PHONY: regen-vcs-version
1071 84a12e40 Iustin Pop
regen-vcs-version:
1072 e8230860 Michael Hanselmann
	set -e; \
1073 84a12e40 Iustin Pop
	cd $(srcdir); \
1074 84a12e40 Iustin Pop
	if test -d .git; then \
1075 316dc1ff Iustin Pop
	  $(MAKE) clean-vcs-version; \
1076 84a12e40 Iustin Pop
	  $(MAKE) vcs-version; \
1077 84a12e40 Iustin Pop
	fi
1078 84a12e40 Iustin Pop
1079 d6159933 Iustin Pop
htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
1080 d6159933 Iustin Pop
	set -e; \
1081 d6159933 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1082 d6159933 Iustin Pop
	sed -e "s/%ver%/$$VCSVER/" < $< > $@
1083 d6159933 Iustin Pop
1084 d99d1e36 Iustin Pop
htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1085 f11e524b Iustin Pop
	lib/constants.py lib/_autoconf.py lib/luxi.py \
1086 f11e524b Iustin Pop
	$(CONVERT_CONSTANTS) \
1087 ef958f2a Iustin Pop
	| lib/_vcsversion.py
1088 11fd5a86 Iustin Pop
	set -e; \
1089 876f6a5e Iustin Pop
	{ cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1090 d99d1e36 Iustin Pop
1091 13aeae6a Iustin Pop
lib/_autoconf.py: Makefile | lib/.dir
1092 84a12e40 Iustin Pop
	set -e; \
1093 e8230860 Michael Hanselmann
	{ echo '# This file is automatically generated, do not edit!'; \
1094 e8230860 Michael Hanselmann
	  echo '#'; \
1095 67047322 Iustin Pop
	  echo ''; \
1096 67047322 Iustin Pop
	  echo '"""Build-time configuration for Ganeti.'; \
1097 67047322 Iustin Pop
	  echo '';\
1098 67047322 Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1099 67047322 Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1100 67047322 Iustin Pop
	  echo 'not edit by hand).'; \
1101 67047322 Iustin Pop
	  echo ''; \
1102 67047322 Iustin Pop
	  echo '"""'; \
1103 67047322 Iustin Pop
	  echo ''; \
1104 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1105 0a4e7f24 Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1106 0a4e7f24 Iustin Pop
	  echo '# style warnings' ; \
1107 0a4e7f24 Iustin Pop
	  echo ''; \
1108 e8230860 Michael Hanselmann
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1109 e8230860 Michael Hanselmann
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1110 e8230860 Michael Hanselmann
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1111 e8230860 Michael Hanselmann
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1112 e8230860 Michael Hanselmann
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1113 e8230860 Michael Hanselmann
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1114 e8230860 Michael Hanselmann
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1115 e8230860 Michael Hanselmann
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
1116 553bd93f Vitaly Kuznetsov
	  echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1117 e8230860 Michael Hanselmann
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1118 e8230860 Michael Hanselmann
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1119 868eab67 Constantinos Venetsanopoulos
	  echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1120 2f2dbb4b Jun Futagawa
	  echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1121 e8230860 Michael Hanselmann
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1122 e8230860 Michael Hanselmann
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1123 b8203e1e Iustin Pop
	  echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1124 e8230860 Michael Hanselmann
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1125 cb7c0198 Iustin Pop
	  echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1126 4b97f902 Apollon Oikonomopoulos
	  echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1127 4b97f902 Apollon Oikonomopoulos
	  echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1128 e8230860 Michael Hanselmann
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1129 7e2c5b9e Guido Trotter
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
1130 c4dfb0b6 Andrea Spadaccini
	  echo "IP_PATH = '$(IP_PATH)'"; \
1131 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_PATH = '$(SOCAT)'"; \
1132 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1133 e90739d6 Michael Hanselmann
	  echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1134 bea60381 Michael Hanselmann
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1135 bea60381 Michael Hanselmann
	  echo "TOOLSDIR = '$(toolsdir)'"; \
1136 4f3d5b76 Michael Hanselmann
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1137 f154a7a3 Michael Hanselmann
	  echo "PKGLIBDIR = '$(pkglibdir)'"; \
1138 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1139 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1140 551b6283 Iustin Pop
	  echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1141 8b72b05c René Nussbaumer
	  echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1142 f12e1736 René Nussbaumer
	  echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1143 8b72b05c René Nussbaumer
	  echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1144 f12e1736 René Nussbaumer
	  echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1145 8b72b05c René Nussbaumer
	  echo "RAPI_USER = '$(RAPI_USER)'"; \
1146 f12e1736 René Nussbaumer
	  echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1147 f12e1736 René Nussbaumer
	  echo "CONFD_USER = '$(CONFD_USER)'"; \
1148 f12e1736 René Nussbaumer
	  echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1149 f12e1736 René Nussbaumer
	  echo "NODED_USER = '$(NODED_USER)'"; \
1150 03881cb0 René Nussbaumer
	  echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1151 3536c792 Iustin Pop
	  echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1152 a002ed79 Agata Murawska
	  echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1153 e5395072 Iustin Pop
	  if [ "$(HTOOLS)" ]; then \
1154 e5395072 Iustin Pop
	    echo "HTOOLS = True"; \
1155 e5395072 Iustin Pop
	  else \
1156 e5395072 Iustin Pop
	    echo "HTOOLS = False"; \
1157 e5395072 Iustin Pop
	  fi; \
1158 cd8b0072 Iustin Pop
	  echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1159 73b0fa69 Iustin Pop
	  echo "PY_CONFD = $(PY_CONFD)"; \
1160 73b0fa69 Iustin Pop
	  echo "HS_CONFD = $(HS_CONFD)"; \
1161 1eb37421 René Nussbaumer
	  echo "XEN_CMD = '$(XEN_CMD)'"; \
1162 e8230860 Michael Hanselmann
	} > $@
1163 e8230860 Michael Hanselmann
1164 13aeae6a Iustin Pop
lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1165 13aeae6a Iustin Pop
	set -e; \
1166 13aeae6a Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1167 13aeae6a Iustin Pop
	{ echo '# This file is automatically generated, do not edit!'; \
1168 13aeae6a Iustin Pop
	  echo '#'; \
1169 13aeae6a Iustin Pop
	  echo ''; \
1170 13aeae6a Iustin Pop
	  echo '"""Build-time VCS version number for Ganeti.'; \
1171 13aeae6a Iustin Pop
	  echo '';\
1172 13aeae6a Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1173 13aeae6a Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1174 13aeae6a Iustin Pop
	  echo 'not edit by hand).'; \
1175 13aeae6a Iustin Pop
	  echo ''; \
1176 13aeae6a Iustin Pop
	  echo '"""'; \
1177 13aeae6a Iustin Pop
	  echo ''; \
1178 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1179 13aeae6a Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1180 13aeae6a Iustin Pop
	  echo '# style warnings' ; \
1181 13aeae6a Iustin Pop
	  echo ''; \
1182 13aeae6a Iustin Pop
	  echo "VCS_VERSION = '$$VCSVER'"; \
1183 13aeae6a Iustin Pop
	} > $@
1184 13aeae6a Iustin Pop
1185 96a7481d Michael Hanselmann
lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1186 96a7481d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1187 d5a2a550 Michael Hanselmann
1188 dbefcc7e Michael Hanselmann
$(REPLACE_VARS_SED): Makefile
1189 e8230860 Michael Hanselmann
	set -e; \
1190 e8230860 Michael Hanselmann
	{ echo 's#@PREFIX@#$(prefix)#g'; \
1191 e8230860 Michael Hanselmann
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1192 e8230860 Michael Hanselmann
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1193 7a2ba406 Luca Bigliardi
	  echo 's#@BINDIR@#$(bindir)#g'; \
1194 e8230860 Michael Hanselmann
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
1195 e8230860 Michael Hanselmann
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1196 2f2dbb4b Jun Futagawa
	  echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1197 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1198 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1199 56956bcb Iustin Pop
	  echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1200 56956bcb Iustin Pop
	  echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1201 d3b4cf9f Iustin Pop
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1202 7e1fac25 Michael Hanselmann
	  echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1203 c5159571 Iustin Pop
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1204 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1205 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1206 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1207 0d150c50 René Nussbaumer
	  echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1208 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1209 0d150c50 René Nussbaumer
	  echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1210 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1211 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1212 46a8da3b René Nussbaumer
	  echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1213 cd8b0072 Iustin Pop
	  echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1214 e8230860 Michael Hanselmann
	} > $@
1215 e8230860 Michael Hanselmann
1216 67313146 Michael Hanselmann
# Using deferred evaluation
1217 899c4d2c Michael Hanselmann
daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1218 9f4bb951 Michael Hanselmann
daemons/ganeti-watcher: MODULE = ganeti.watcher
1219 67313146 Michael Hanselmann
scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1220 0d2bf835 René Nussbaumer
tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1221 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/%,%,$@)
1222 67313146 Michael Hanselmann
1223 c964d962 Michael Hanselmann
$(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1224 67313146 Michael Hanselmann
	test -n "$(MODULE)" || { echo Missing module; exit 1; }
1225 2d48a3a2 Michael Hanselmann
	set -e; \
1226 d75e738e Michael Hanselmann
	{ echo '#!/usr/bin/python'; \
1227 2d48a3a2 Michael Hanselmann
	  echo '# This file is automatically generated, do not edit!'; \
1228 67313146 Michael Hanselmann
	  echo "# Edit $(MODULE) instead."; \
1229 2d48a3a2 Michael Hanselmann
	  echo; \
1230 67313146 Michael Hanselmann
	  echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1231 2d48a3a2 Michael Hanselmann
	  echo; \
1232 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0103'; \
1233 2d48a3a2 Michael Hanselmann
	  echo '# C0103: Invalid name'; \
1234 2d48a3a2 Michael Hanselmann
	  echo; \
1235 2d48a3a2 Michael Hanselmann
	  echo 'import sys'; \
1236 67313146 Michael Hanselmann
	  echo 'import $(MODULE) as main'; \
1237 2d48a3a2 Michael Hanselmann
	  echo; \
1238 2d48a3a2 Michael Hanselmann
	  echo '# Temporarily alias commands until bash completion'; \
1239 2d48a3a2 Michael Hanselmann
	  echo '# generator is changed'; \
1240 67313146 Michael Hanselmann
	  echo 'if hasattr(main, "commands"):'; \
1241 55766d34 Andrea Spadaccini
	  echo '  commands = main.commands # pylint: disable=E1101'; \
1242 3f42b4f6 Michael Hanselmann
	  echo 'if hasattr(main, "aliases"):'; \
1243 55766d34 Andrea Spadaccini
	  echo '  aliases = main.aliases # pylint: disable=E1101'; \
1244 2d48a3a2 Michael Hanselmann
	  echo; \
1245 2d48a3a2 Michael Hanselmann
	  echo 'if __name__ == "__main__":'; \
1246 67313146 Michael Hanselmann
	  echo '  sys.exit(main.Main())'; \
1247 2d48a3a2 Michael Hanselmann
	} > $@
1248 2d48a3a2 Michael Hanselmann
	chmod u+x $@
1249 2d48a3a2 Michael Hanselmann
1250 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): Makefile
1251 3096524e Iustin Pop
	@test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1252 3096524e Iustin Pop
	set -e; \
1253 3096524e Iustin Pop
	{ echo '#!/bin/sh'; \
1254 3096524e Iustin Pop
	  echo '# This file is automatically generated, do not edit!'; \
1255 3096524e Iustin Pop
	  echo "# Edit Makefile.am instead."; \
1256 3096524e Iustin Pop
	  echo; \
1257 3096524e Iustin Pop
	  echo "HTOOLS=$(TESTROLE) exec ./htools/hpc-htools \"\$$@\""; \
1258 3096524e Iustin Pop
	} > $@
1259 3096524e Iustin Pop
	chmod u+x $@
1260 3096524e Iustin Pop
1261 e8230860 Michael Hanselmann
# We need to create symlinks because "make distcheck" will not install Python
1262 e8230860 Michael Hanselmann
# files when building.
1263 c964d962 Michael Hanselmann
stamp-srclinks: Makefile | $(all_dirfiles)
1264 e8230860 Michael Hanselmann
	set -e; \
1265 01a3a718 Michael Hanselmann
	for i in $(srclink_files); do \
1266 e8230860 Michael Hanselmann
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1267 e8230860 Michael Hanselmann
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
1268 e8230860 Michael Hanselmann
		fi; \
1269 e8230860 Michael Hanselmann
	done
1270 dd1dfd9a Michael Hanselmann
	touch $@
1271 97a37b3f Michael Hanselmann
1272 9ff7e35c Michael Hanselmann
.PHONY: ganeti
1273 9ff7e35c Michael Hanselmann
ganeti:
1274 01f3e7b1 Iustin Pop
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1275 9ff7e35c Michael Hanselmann
1276 6b997854 Michael Hanselmann
.PHONY: check-dirs
1277 6b997854 Michael Hanselmann
check-dirs: $(BUILT_SOURCES)
1278 0c1103d6 Iustin Pop
	@set -e; \
1279 6b997854 Michael Hanselmann
	find . -type d \( \( -name . \) -o \( \
1280 6b997854 Michael Hanselmann
		-name .git -o \
1281 6b997854 Michael Hanselmann
		-name autom4te.cache \
1282 6b997854 Michael Hanselmann
		\) -prune -o -print \) | { \
1283 6b997854 Michael Hanselmann
		error=; \
1284 6b997854 Michael Hanselmann
		while read dir; do \
1285 6b997854 Michael Hanselmann
			case "$$dir" in \
1286 6b997854 Michael Hanselmann
				$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1287 6b997854 Michael Hanselmann
				*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1288 6b997854 Michael Hanselmann
			esac; \
1289 6b997854 Michael Hanselmann
		done; \
1290 6b997854 Michael Hanselmann
		for dir in $(DIRS); do \
1291 6b997854 Michael Hanselmann
			if ! test -d "$$dir"; then \
1292 6b997854 Michael Hanselmann
				echo "Directory $$dir listed in DIRS does not exist" >&2; \
1293 6b997854 Michael Hanselmann
				error=1; \
1294 6b997854 Michael Hanselmann
			fi \
1295 6b997854 Michael Hanselmann
		done; \
1296 6b997854 Michael Hanselmann
		if test -n "$$error"; then exit 1; else exit 0; fi; \
1297 6b997854 Michael Hanselmann
	}
1298 6b997854 Michael Hanselmann
1299 f6cbcc06 Michael Hanselmann
.PHONY: check-local
1300 f6cbcc06 Michael Hanselmann
check-local: check-dirs $(BUILT_SOURCES)
1301 eed5c5df Michael Hanselmann
	$(CHECK_PYTHON_CODE) $(check_python_code)
1302 5d3c30df Michael Hanselmann
	PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1303 35576615 Michael Hanselmann
	$(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1304 7385c51d Michael Hanselmann
	$(CHECK_NEWS) < $(top_srcdir)/NEWS
1305 83ea5145 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1306 9488fd1d Michael Hanselmann
	expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1307 154d7ba5 Michael Hanselmann
	if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1308 9488fd1d Michael Hanselmann
		echo "Incorrect version in README, expected $$expver"; \
1309 9488fd1d Michael Hanselmann
		exit 1; \
1310 7ecb3d0e Michael Hanselmann
	fi; \
1311 d5114fa1 Michael Hanselmann
	for file in doc/iallocator.rst doc/hooks.rst; do \
1312 d5114fa1 Michael Hanselmann
		if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1313 9822b1dd Iustin Pop
			"Documents Ganeti version $$expver"; then \
1314 d5114fa1 Michael Hanselmann
			echo "Incorrect version in $$file, expected $$expver"; \
1315 d5114fa1 Michael Hanselmann
			exit 1; \
1316 d5114fa1 Michael Hanselmann
		fi; \
1317 d5114fa1 Michael Hanselmann
	done
1318 eed5c5df Michael Hanselmann
1319 49e11c49 Iustin Pop
.PHONY: hs-check
1320 3096524e Iustin Pop
hs-check: htools/test htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
1321 49e11c49 Iustin Pop
	@rm -f test.tix
1322 49e11c49 Iustin Pop
	./htools/test
1323 896b2850 Iustin Pop
	HBINARY="./htools/hpc-htools" ./htools/offline-test.sh
1324 49e11c49 Iustin Pop
1325 08366664 Michael Hanselmann
# E111: indentation is not a multiple of four
1326 08366664 Michael Hanselmann
# E261: at least two spaces before inline comment
1327 08366664 Michael Hanselmann
# E501: line too long (80 characters)
1328 08366664 Michael Hanselmann
PEP8_IGNORE = E111,E261,E501
1329 08366664 Michael Hanselmann
1330 08366664 Michael Hanselmann
# For excluding pep8 expects filenames only, not whole paths
1331 08366664 Michael Hanselmann
PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1332 08366664 Michael Hanselmann
1333 6e4c8f68 Iustin Pop
LINT_TARGETS = pylint pylint-qa
1334 6e4c8f68 Iustin Pop
if HAS_PEP8
1335 6e4c8f68 Iustin Pop
LINT_TARGETS += pep8
1336 6e4c8f68 Iustin Pop
endif
1337 6e4c8f68 Iustin Pop
if HAS_HLINT
1338 6e4c8f68 Iustin Pop
LINT_TARGETS += hlint
1339 6e4c8f68 Iustin Pop
endif
1340 6e4c8f68 Iustin Pop
1341 e0098923 Iustin Pop
.PHONY: lint
1342 6e4c8f68 Iustin Pop
lint: $(LINT_TARGETS)
1343 6e4c8f68 Iustin Pop
1344 6e4c8f68 Iustin Pop
.PHONY: pylint
1345 6e4c8f68 Iustin Pop
pylint: $(BUILT_SOURCES)
1346 6d7cc5ff Michael Hanselmann
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1347 6d7cc5ff Michael Hanselmann
	$(PYLINT) $(LINT_OPTS) $(lint_python_code)
1348 6e4c8f68 Iustin Pop
1349 6e4c8f68 Iustin Pop
.PHONY: pylint-qa
1350 6e4c8f68 Iustin Pop
pylint-qa: $(BUILT_SOURCES)
1351 6e4c8f68 Iustin Pop
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1352 3582eef6 Iustin Pop
	cd $(top_srcdir)/qa && \
1353 3582eef6 Iustin Pop
	  PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1354 3582eef6 Iustin Pop
	  --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1355 e0098923 Iustin Pop
1356 6e4c8f68 Iustin Pop
.PHONY: pep8
1357 6e4c8f68 Iustin Pop
pep8: $(BUILT_SOURCES)
1358 6e4c8f68 Iustin Pop
	@test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1359 6e4c8f68 Iustin Pop
	$(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1360 6e4c8f68 Iustin Pop
		--repeat $(pep8_python_code)
1361 6e4c8f68 Iustin Pop
1362 191ff68c Iustin Pop
.PHONY: hlint
1363 5a1e31b4 Iustin Pop
hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1364 6e4c8f68 Iustin Pop
	@test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1365 191ff68c Iustin Pop
	if tty -s; then C="-c"; else C=""; fi; \
1366 6e4c8f68 Iustin Pop
	$(HLINT) --report=doc/hs-lint.html --cross $$C \
1367 3603605a Iustin Pop
	  --ignore "Use first" \
1368 3603605a Iustin Pop
	  --ignore "Use comparing" \
1369 3603605a Iustin Pop
	  --ignore "Use on" \
1370 3603605a Iustin Pop
	  --ignore "Reduce duplication" \
1371 5a1e31b4 Iustin Pop
	  --hint htools/lint-hints \
1372 3603605a Iustin Pop
	  $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1373 191ff68c Iustin Pop
1374 84a12e40 Iustin Pop
# a dist hook rule for updating the vcs-version file; this is
1375 84a12e40 Iustin Pop
# hardcoded due to where it needs to build the file...
1376 84a12e40 Iustin Pop
dist-hook:
1377 316dc1ff Iustin Pop
	$(MAKE) regen-vcs-version
1378 316dc1ff Iustin Pop
	rm -f $(top_distdir)/vcs-version
1379 84a12e40 Iustin Pop
	cp -p $(srcdir)/vcs-version $(top_distdir)
1380 84a12e40 Iustin Pop
1381 84a12e40 Iustin Pop
# a distcheck hook rule for catching revision control directories
1382 b6f2e47f Iustin Pop
distcheck-hook:
1383 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1384 c6aa0c42 Michael Hanselmann
		echo "Found revision control files in final archive." 1>&2; \
1385 c6aa0c42 Michael Hanselmann
		exit 1; \
1386 c6aa0c42 Michael Hanselmann
	fi
1387 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*.py[co]' | grep .; then \
1388 c6aa0c42 Michael Hanselmann
		echo "Found Python byte code in final archive." 1>&2; \
1389 c6aa0c42 Michael Hanselmann
		exit 1; \
1390 c6aa0c42 Michael Hanselmann
	fi
1391 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*~' | grep .; then \
1392 c6aa0c42 Michael Hanselmann
		echo "Found backup files in final archive." 1>&2; \
1393 b6f2e47f Iustin Pop
		exit 1; \
1394 b6f2e47f Iustin Pop
	fi
1395 bf0b21da Michael Hanselmann
# Empty files or directories should not be distributed. They can cause
1396 bf0b21da Michael Hanselmann
# unnecessary warnings for packagers. Directories used by automake during
1397 bf0b21da Michael Hanselmann
# distcheck must be excluded.
1398 bf0b21da Michael Hanselmann
	if find $(top_distdir) -empty -and -not \( \
1399 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_build -or \
1400 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_inst \) | grep .; then \
1401 bf0b21da Michael Hanselmann
		echo "Found empty files or directories in final archive." 1>&2; \
1402 bf0b21da Michael Hanselmann
		exit 1; \
1403 bf0b21da Michael Hanselmann
	fi
1404 c7b86f6c Michael Hanselmann
	if test -n "$(BUILD_RELEASE)" && \
1405 c7b86f6c Michael Hanselmann
	   grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1406 c7b86f6c Michael Hanselmann
		echo "Found unreleased version in NEWS." >&2; \
1407 c7b86f6c Michael Hanselmann
		exit 1; \
1408 c7b86f6c Michael Hanselmann
	fi
1409 c7b86f6c Michael Hanselmann
1410 c7b86f6c Michael Hanselmann
# When building a release, stricter checks should be used
1411 e627fe09 Michael Hanselmann
distcheck-release dist-release: export BUILD_RELEASE = 1
1412 c7b86f6c Michael Hanselmann
distcheck-release: distcheck
1413 b6f2e47f Iustin Pop
1414 7213dded René Nussbaumer
distrebuildcheck: dist
1415 7213dded René Nussbaumer
	set -e; \
1416 7213dded René Nussbaumer
	builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1417 7213dded René Nussbaumer
	trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1418 7213dded René Nussbaumer
	cd $$builddir; \
1419 7213dded René Nussbaumer
	tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1420 7213dded René Nussbaumer
	cd $(distdir); \
1421 7213dded René Nussbaumer
	./configure; \
1422 7213dded René Nussbaumer
	$(MAKE) maintainer-clean; \
1423 7213dded René Nussbaumer
	cp $(abs_srcdir)/vcs-version .; \
1424 7213dded René Nussbaumer
	./configure; \
1425 7213dded René Nussbaumer
	$(MAKE) $(AM_MAKEFLAGS)
1426 7213dded René Nussbaumer
1427 e627fe09 Michael Hanselmann
dist-release: dist
1428 e627fe09 Michael Hanselmann
	set -e; \
1429 e627fe09 Michael Hanselmann
	for i in $(DIST_ARCHIVES); do \
1430 e627fe09 Michael Hanselmann
		echo -n "Checking $$i ... "; \
1431 e627fe09 Michael Hanselmann
		autotools/check-tar < $$i; \
1432 e627fe09 Michael Hanselmann
		echo OK; \
1433 e627fe09 Michael Hanselmann
	done
1434 e627fe09 Michael Hanselmann
1435 8925faaa Iustin Pop
install-exec-local:
1436 0d93b082 Michael Hanselmann
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1437 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
1438 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/run/ganeti"
1439 e8230860 Michael Hanselmann
1440 c964d962 Michael Hanselmann
# To avoid conflicts between directory names and other targets, a file inside
1441 c964d962 Michael Hanselmann
# the directory is used to ensure its existence.
1442 c964d962 Michael Hanselmann
%.dir:
1443 c964d962 Michael Hanselmann
	@mkdir_p@ $* && touch $@
1444 e8230860 Michael Hanselmann
1445 d128fdb6 Iustin Pop
.PHONY: apidoc
1446 a38bfce5 Iustin Pop
if WANT_HTOOLSAPIDOC
1447 a38bfce5 Iustin Pop
apidoc: py-apidoc hs-apidoc
1448 a38bfce5 Iustin Pop
else
1449 a38bfce5 Iustin Pop
apidoc: py-apidoc
1450 a38bfce5 Iustin Pop
endif
1451 a38bfce5 Iustin Pop
1452 a38bfce5 Iustin Pop
.PHONY: py-apidoc
1453 a38bfce5 Iustin Pop
py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1454 b959138f Michael Hanselmann
	$(RUN_IN_TEMPDIR) epydoc -v \
1455 b959138f Michael Hanselmann
		--conf $(CURDIR)/epydoc.conf \
1456 22c5390d Iustin Pop
		--output $(CURDIR)/$(APIDOC_PY_DIR)
1457 a38bfce5 Iustin Pop
1458 a38bfce5 Iustin Pop
.PHONY: hs-apidoc
1459 c3f67183 Iustin Pop
hs-apidoc: $(HS_BUILT_SRCS)
1460 a38bfce5 Iustin Pop
	@test -n "$(HSCOLOUR)" || \
1461 a38bfce5 Iustin Pop
	    { echo 'HsColour' not found during configure; exit 1; }
1462 a38bfce5 Iustin Pop
	@test -n "$(HADDOCK)" || \
1463 a38bfce5 Iustin Pop
	    { echo 'haddock' not found during configure; exit 1; }
1464 22c5390d Iustin Pop
	rm -rf $(APIDOC_HS_DIR)/*
1465 458a286a Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1466 358a0a8f Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1467 22c5390d Iustin Pop
	$(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1468 82888134 Michael Hanselmann
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1469 358a0a8f Iustin Pop
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1470 a38bfce5 Iustin Pop
	set -e ; \
1471 a38bfce5 Iustin Pop
	cd htools; \
1472 c478f837 Iustin Pop
	if [ "$(HTOOLS_NOCURL)" ]; \
1473 c478f837 Iustin Pop
	then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1474 c478f837 Iustin Pop
	else OPTGHC=""; \
1475 c478f837 Iustin Pop
	fi; \
1476 1adec4be Iustin Pop
	if [ "$(HTOOLS_PARALLEL3)" ]; \
1477 1adec4be Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1478 1adec4be Iustin Pop
	fi; \
1479 606e71d3 Iustin Pop
	RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1480 a38bfce5 Iustin Pop
	for file in $$RELSRCS; do \
1481 a38bfce5 Iustin Pop
		hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1482 22c5390d Iustin Pop
		$(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1483 a38bfce5 Iustin Pop
	done ; \
1484 22c5390d Iustin Pop
	$(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1485 a38bfce5 Iustin Pop
		-t ganeti-htools -p haddock-prologue \
1486 a38bfce5 Iustin Pop
		--source-module="%{MODULE/.//}.html" \
1487 a38bfce5 Iustin Pop
		--source-entity="%{MODULE/.//}.html#%{NAME}" \
1488 c478f837 Iustin Pop
		$$OPTGHC \
1489 c3f67183 Iustin Pop
		$(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1490 d128fdb6 Iustin Pop
1491 13e720f1 Iustin Pop
.PHONY: TAGS
1492 eb732fb5 Michael Hanselmann
TAGS: $(BUILT_SOURCES)
1493 13e720f1 Iustin Pop
	rm -f TAGS
1494 74fa8200 Iustin Pop
	find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1495 74fa8200 Iustin Pop
	  -path './daemons/ganeti-*' -o -path './tools/*' -o \
1496 74fa8200 Iustin Pop
	  -path './qa/*.py' | \
1497 3bb5c580 Iustin Pop
	  etags -l python -
1498 13e720f1 Iustin Pop
1499 27e336af Michael Hanselmann
.PHONY: coverage
1500 b91e9518 Iustin Pop
if WANT_HTOOLS
1501 b91e9518 Iustin Pop
coverage: py-coverage hs-coverage
1502 b91e9518 Iustin Pop
else
1503 b91e9518 Iustin Pop
coverage: py-coverage
1504 b91e9518 Iustin Pop
endif
1505 b91e9518 Iustin Pop
1506 b91e9518 Iustin Pop
.PHONY: py-coverage
1507 b91e9518 Iustin Pop
py-coverage: $(BUILT_SOURCES) $(python_tests)
1508 27e336af Michael Hanselmann
	set -e; \
1509 22c5390d Iustin Pop
	COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1510 22c5390d Iustin Pop
	TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1511 22c5390d Iustin Pop
	HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1512 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1513 e8c8cf1a Michael Hanselmann
	$(python_tests)
1514 27e336af Michael Hanselmann
1515 b91e9518 Iustin Pop
.PHONY: hs-coverage
1516 896b2850 Iustin Pop
hs-coverage: $(haskell_tests) htools/hpc-htools
1517 316dc1ff Iustin Pop
	rm -f *.tix
1518 316dc1ff Iustin Pop
	$(MAKE) hs-check
1519 48f12e73 Iustin Pop
	@mkdir_p@ $(COVERAGE_HS_DIR)
1520 896b2850 Iustin Pop
	hpc combine $(HPCEXCL) test.tix hpc-htools.tix > coverage-htools.tix
1521 896b2850 Iustin Pop
	hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1522 896b2850 Iustin Pop
	hpc report coverage-htools.tix
1523 82888134 Michael Hanselmann
	$(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1524 b91e9518 Iustin Pop
1525 ec8379bd Iustin Pop
# Special "kind-of-QA" target for htools, needs special setup (all
1526 ec8379bd Iustin Pop
# tools compiled with -fhpc)
1527 ec8379bd Iustin Pop
.PHONY: live-test
1528 ec8379bd Iustin Pop
live-test: all
1529 ec8379bd Iustin Pop
	set -e ; \
1530 ec8379bd Iustin Pop
	cd htools; \
1531 82888134 Michael Hanselmann
	rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1532 ec8379bd Iustin Pop
	rm -f *.tix *.mix; \
1533 ec8379bd Iustin Pop
	./live-test.sh; \
1534 c3f67183 Iustin Pop
	hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1535 ec8379bd Iustin Pop
	  --output=live-test.tix ; \
1536 22c5390d Iustin Pop
	@mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1537 22c5390d Iustin Pop
	hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1538 ec8379bd Iustin Pop
		--srcdir=.. $(HPCEXCL) ; \
1539 ec8379bd Iustin Pop
	hpc report --srcdir=.. live-test $(HPCEXCL)
1540 b91e9518 Iustin Pop
1541 b341b9ca Guido Trotter
commit-check: distcheck lint apidoc
1542 b341b9ca Guido Trotter
1543 6438e259 Iustin Pop
.PHONY: gitignore-check
1544 6438e259 Iustin Pop
gitignore-check:
1545 6438e259 Iustin Pop
	@if [ -n "`git status --short`" ]; then \
1546 6438e259 Iustin Pop
	  echo "Git status is not clean!" 1>&2 ; \
1547 6438e259 Iustin Pop
	  git status --short; \
1548 6438e259 Iustin Pop
	  exit 1; \
1549 6438e259 Iustin Pop
	fi
1550 6438e259 Iustin Pop
1551 3baa809c Michael Hanselmann
-include ./Makefile.local
1552 3baa809c Michael Hanselmann
1553 e8230860 Michael Hanselmann
# vim: set noet :